$(function(){
var chart = $("#chart").dxChart({
dataSource: dataSource,
title: "Weather in Las Vegas, NV (2017)",
commonSeriesSettings: {
argumentField: "date"
},
argumentAxis: {
argumentType: "datetime",
aggregationInterval: "week",
valueMarginsEnabled: false
},
valueAxis: [{
name: "temperature",
title: {
text: "Temperature, °C",
font: {
color: "#e91e63"
}
},
label: {
font: {
color: "#e91e63"
}
}
}, {
name: "precipitation",
position: "right",
title: {
text: "Precipitation, mm",
font: {
color: "#03a9f4"
}
},
label: {
font: {
color: "#03a9f4"
}
}
}
],
legend: {
visible: false
},
series: [{
axis: "precipitation",
color: "#03a9f4",
type: "bar",
valueField: "precip",
name: "Precipitation"
}, {
axis: "temperature",
color: "#ffc0bb",
type: "rangeArea",
rangeValue1Field: "minTemp",
rangeValue2Field: "maxTemp",
aggregation: {
enabled: true,
method: "custom",
calculate: function(aggregationInfo, series) {
if(!aggregationInfo.data.length) {
return;
}
var temp = aggregationInfo.data.map(function(item) { return item.temp; }),
maxTemp = Math.max.apply(null, temp),
minTemp = Math.min.apply(null, temp);
return {
date: aggregationInfo.intervalStart,
maxTemp: maxTemp,
minTemp: minTemp
};
}
},
name: "Temperature range"
}, {
axis: "temperature",
color: "#e91e63",
valueField: "temp",
point: {
size: 7
},
aggregation: {
enabled: true
},
name: "Average temperature"
}],
tooltip: {
enabled: true,
customizeTooltip: function (arg) {
return customTooltipHandlers[arg.seriesName](arg, arg.point.aggregationInfo);
}
}
}).dxChart("instance");
$("#useAggregationToggle").dxCheckBox({
text: "Aggregation enabled",
value: true,
onValueChanged: function(data) {
chart.option("series[1].aggregation.enabled", data.value);
chart.option("series[2].aggregation.enabled", data.value);
}
});
$("#aggregateIntervalSelector").dxSelectBox({
items: intervals,
value: "week",
valueExpr: "interval",
displayExpr: "displayName",
onValueChanged: function(data) {
chart.option("argumentAxis.aggregationInterval", data.value);
}
});
$("#aggregateFunctionSelector").dxSelectBox({
items: functions,
value: "avg",
valueExpr: "func",
displayExpr: "displayName",
onValueChanged: function(data) {
chart.option("series[2].aggregation.method", data.value);
}
});
var customTooltipHandlers = {
"Average temperature": function(arg, aggregationInfo) {
var start = aggregationInfo && aggregationInfo.intervalStart,
end = aggregationInfo && aggregationInfo.intervalEnd;
return {
text: (!aggregationInfo ?
"Date: " + arg.argument.toDateString() :
"Interval: " + start.toDateString() +
" - " + end.toDateString()) +
"<br/>Temperature: " + arg.value.toFixed(2) + " °C"
};
},
"Temperature range": function(arg, aggregationInfo) {
var start = aggregationInfo.intervalStart,
end = aggregationInfo.intervalEnd;
return {
text: "Interval: " + start.toDateString() +
" - " + end.toDateString() +
"<br/>Temperature range: " + arg.rangeValue1 +
" - " + arg.rangeValue2 + " °C"
};
},
"Precipitation": function(arg) {
return {
text: "Date: " + arg.argument.toDateString() +
"<br/>Precipitation: " + arg.valueText + " mm"
};
}
};
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/19.2.4/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="chart-demo">
<div id="chart"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div id="useAggregationToggle"></div>
</div>
<div class="option">
<span>Interval:</span>
<div id="aggregateIntervalSelector"></div>
</div>
<div class="option">
<span>Method:</span>
<div id="aggregateFunctionSelector"></div>
</div>
</div>
</div>
</div>
</body>
</html>
#chart-demo {
height: 700px;
width: 100%;
}
#chart {
height: 500px;
margin: 0 0 15px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
width: 50px;
display: inline-block;
margin-right: 10px;
}
.option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
}
var intervals = [{
displayName: "One week",
interval: "week"
}, {
displayName: "Two weeks",
interval: { weeks: 2 }
}, {
displayName: "Month",
interval: "month"
}];
var functions = [{
displayName: "Average",
func: "avg"
}, {
displayName: "Minimum",
func: "min"
}, {
displayName: "Maximum",
func: "max"
}];
var dataSource = [{
"date":"2017-01-01",
"temp":9.5,
"precip":0.1
},
{
"date":"2017-01-02",
"temp":8,
"precip":0.4
},
{
"date":"2017-01-03",
"temp":7.5,
"precip":0.2
},
{
"date":"2017-01-04",
"temp":8.5,
"precip":0.1
},
{
"date":"2017-01-05",
"temp":10,
"precip":0.3
},
{
"date":"2017-01-06",
"temp":3,
"precip":0
},
{
"date":"2017-01-07",
"temp":5,
"precip":0.3
},
{
"date":"2017-01-08",
"temp":9.5,
"precip":0
},
{
"date":"2017-01-09",
"temp":11,
"precip":0.5
},
{
"date":"2017-01-10",
"temp":8,
"precip":0
},
{
"date":"2017-01-11",
"temp":11.5,
"precip":0.3
},
{
"date":"2017-01-12",
"temp":9.5,
"precip":2.1
},
{
"date":"2017-01-13",
"temp":11.5,
"precip":3.5
},
{
"date":"2017-01-14",
"temp":11,
"precip":0.1
},
{
"date":"2017-01-15",
"temp":10.5,
"precip":0
},
{
"date":"2017-01-16",
"temp":6.5,
"precip":0
},
{
"date":"2017-01-17",
"temp":7.5,
"precip":0
},
{
"date":"2017-01-18",
"temp":8,
"precip":0.1
},
{
"date":"2017-01-19",
"temp":8.5,
"precip":1.3
},
{
"date":"2017-01-20",
"temp":5.5,
"precip":5.3
},
{
"date":"2017-01-21",
"temp":9,
"precip":0.1
},
{
"date":"2017-01-22",
"temp":6,
"precip":16.6
},
{
"date":"2017-01-23",
"temp":8.5,
"precip":5.5
},
{
"date":"2017-01-24",
"temp":6.5,
"precip":1.3
},
{
"date":"2017-01-25",
"temp":4.5,
"precip":0
},
{
"date":"2017-01-26",
"temp":5.5,
"precip":0
},
{
"date":"2017-01-27",
"temp":3,
"precip":0
},
{
"date":"2017-01-28",
"temp":6.5,
"precip":0
},
{
"date":"2017-01-29",
"temp":8,
"precip":0
},
{
"date":"2017-01-30",
"temp":10.5,
"precip":0
},
{
"date":"2017-01-31",
"temp":13,
"precip":0
},
{
"date":"2017-02-01",
"temp":10.5,
"precip":0
},
{
"date":"2017-02-02",
"temp":12,
"precip":0
},
{
"date":"2017-02-03",
"temp":13,
"precip":0.2
},
{
"date":"2017-02-04",
"temp":10,
"precip":0
},
{
"date":"2017-02-05",
"temp":11.5,
"precip":0
},
{
"date":"2017-02-06",
"temp":11.5,
"precip":0.1
},
{
"date":"2017-02-07",
"temp":12.5,
"precip":0.5
},
{
"date":"2017-02-08",
"temp":13,
"precip":0
},
{
"date":"2017-02-09",
"temp":15.5,
"precip":0
},
{
"date":"2017-02-10",
"temp":16.5,
"precip":0.1
},
{
"date":"2017-02-11",
"temp":14.5,
"precip":0.8
},
{
"date":"2017-02-12",
"temp":13.5,
"precip":0.1
},
{
"date":"2017-02-13",
"temp":13.5,
"precip":0
},
{
"date":"2017-02-14",
"temp":12,
"precip":0
},
{
"date":"2017-02-15",
"temp":13.5,
"precip":0
},
{
"date":"2017-02-16",
"temp":14.5,
"precip":0
},
{
"date":"2017-02-17",
"temp":12.5,
"precip":4.5
},
{
"date":"2017-02-18",
"temp":10,
"precip":14.4
},
{
"date":"2017-02-19",
"temp":13.5,
"precip":0.5
},
{
"date":"2017-02-20",
"temp":14,
"precip":0.6
},
{
"date":"2017-02-21",
"temp":15,
"precip":0
},
{
"date":"2017-02-22",
"temp":11,
"precip":0
},
{
"date":"2017-02-23",
"temp":7.5,
"precip":0
},
{
"date":"2017-02-24",
"temp":6,
"precip":0
},
{
"date":"2017-02-25",
"temp":7,
"precip":0
},
{
"date":"2017-02-26",
"temp":8,
"precip":0
},
{
"date":"2017-02-27",
"temp":8.5,
"precip":0.1
},
{
"date":"2017-02-28",
"temp":10,
"precip":0
},
{
"date":"2017-03-01",
"temp":9,
"precip":0
},
{
"date":"2017-03-02",
"temp":11,
"precip":0
},
{
"date":"2017-03-03",
"temp":15,
"precip":0
},
{
"date":"2017-03-04",
"temp":14.5,
"precip":0
},
{
"date":"2017-03-05",
"temp":12.5,
"precip":0
},
{
"date":"2017-03-06",
"temp":7.5,
"precip":0
},
{
"date":"2017-03-07",
"temp":11,
"precip":0
},
{
"date":"2017-03-08",
"temp":16,
"precip":0
},
{
"date":"2017-03-09",
"temp":19.5,
"precip":0
},
{
"date":"2017-03-10",
"temp":20,
"precip":0
},
{
"date":"2017-03-11",
"temp":20.5,
"precip":0
},
{
"date":"2017-03-12",
"temp":21.5,
"precip":0
},
{
"date":"2017-03-13",
"temp":21.5,
"precip":0
},
{
"date":"2017-03-14",
"temp":23.5,
"precip":0
},
{
"date":"2017-03-15",
"temp":23,
"precip":0
},
{
"date":"2017-03-16",
"temp":23,
"precip":0
},
{
"date":"2017-03-17",
"temp":22.5,
"precip":0
},
{
"date":"2017-03-18",
"temp":23.5,
"precip":0
},
{
"date":"2017-03-19",
"temp":24,
"precip":0
},
{
"date":"2017-03-20",
"temp":23.5,
"precip":0
},
{
"date":"2017-03-21",
"temp":22,
"precip":0
},
{
"date":"2017-03-22",
"temp":18.5,
"precip":4
},
{
"date":"2017-03-23",
"temp":15,
"precip":2.4
},
{
"date":"2017-03-24",
"temp":20.5,
"precip":0
},
{
"date":"2017-03-25",
"temp":19,
"precip":0
},
{
"date":"2017-03-26",
"temp":18.5,
"precip":0
},
{
"date":"2017-03-27",
"temp":18,
"precip":0
},
{
"date":"2017-03-28",
"temp":17,
"precip":0
},
{
"date":"2017-03-29",
"temp":21,
"precip":0
},
{
"date":"2017-03-30",
"temp":19.5,
"precip":0
},
{
"date":"2017-03-31",
"temp":16.5,
"precip":0.2
},
{
"date":"2017-04-01",
"temp":19,
"precip":0
},
{
"date":"2017-04-02",
"temp":20,
"precip":0
},
{
"date":"2017-04-03",
"temp":18,
"precip":0
},
{
"date":"2017-04-04",
"temp":16.5,
"precip":0
},
{
"date":"2017-04-05",
"temp":17,
"precip":0
},
{
"date":"2017-04-06",
"temp":21.5,
"precip":0
},
{
"date":"2017-04-07",
"temp":22,
"precip":0
},
{
"date":"2017-04-08",
"temp":19,
"precip":0.2
},
{
"date":"2017-04-09",
"temp":14.5,
"precip":0
},
{
"date":"2017-04-10",
"temp":17,
"precip":0
},
{
"date":"2017-04-11",
"temp":19.5,
"precip":0
},
{
"date":"2017-04-12",
"temp":21.5,
"precip":0
},
{
"date":"2017-04-13",
"temp":21.5,
"precip":0
},
{
"date":"2017-04-14",
"temp":19,
"precip":0
},
{
"date":"2017-04-15",
"temp":21,
"precip":0
},
{
"date":"2017-04-16",
"temp":22.5,
"precip":0
},
{
"date":"2017-04-17",
"temp":21.5,
"precip":0
},
{
"date":"2017-04-18",
"temp":21.5,
"precip":0
},
{
"date":"2017-04-19",
"temp":21.5,
"precip":0
},
{
"date":"2017-04-20",
"temp":22,
"precip":0
},
{
"date":"2017-04-21",
"temp":20,
"precip":0
},
{
"date":"2017-04-22",
"temp":23,
"precip":0
},
{
"date":"2017-04-23",
"temp":26,
"precip":0
},
{
"date":"2017-04-24",
"temp":25,
"precip":0
},
{
"date":"2017-04-25",
"temp":22,
"precip":0
},
{
"date":"2017-04-26",
"temp":23.5,
"precip":0
},
{
"date":"2017-04-27",
"temp":23,
"precip":0
},
{
"date":"2017-04-28",
"temp":19,
"precip":0
},
{
"date":"2017-04-29",
"temp":19.5,
"precip":0
},
{
"date":"2017-04-30",
"temp":21.5,
"precip":0
},
{
"date":"2017-05-01",
"temp":26,
"precip":0
},
{
"date":"2017-05-02",
"temp":26,
"precip":0
},
{
"date":"2017-05-03",
"temp":25.5,
"precip":0
},
{
"date":"2017-05-04",
"temp":28,
"precip":0
},
{
"date":"2017-05-05",
"temp":28.5,
"precip":0
},
{
"date":"2017-05-06",
"temp":27,
"precip":0.4
},
{
"date":"2017-05-07",
"temp":17,
"precip":0.1
},
{
"date":"2017-05-08",
"temp":17,
"precip":0
},
{
"date":"2017-05-09",
"temp":20,
"precip":1.7
},
{
"date":"2017-05-10",
"temp":19.5,
"precip":0.3
},
{
"date":"2017-05-11",
"temp":23,
"precip":0
},
{
"date":"2017-05-12",
"temp":26,
"precip":0
},
{
"date":"2017-05-13",
"temp":22.5,
"precip":0
},
{
"date":"2017-05-14",
"temp":23,
"precip":0
},
{
"date":"2017-05-15",
"temp":19.5,
"precip":0
},
{
"date":"2017-05-16",
"temp":20,
"precip":0
},
{
"date":"2017-05-17",
"temp":18.5,
"precip":0
},
{
"date":"2017-05-18",
"temp":19.5,
"precip":0
},
{
"date":"2017-05-19",
"temp":21.5,
"precip":0
},
{
"date":"2017-05-20",
"temp":24,
"precip":0
},
{
"date":"2017-05-21",
"temp":27.5,
"precip":0
},
{
"date":"2017-05-22",
"temp":29,
"precip":0
},
{
"date":"2017-05-23",
"temp":30.5,
"precip":0
},
{
"date":"2017-05-24",
"temp":31,
"precip":0
},
{
"date":"2017-05-25",
"temp":29.5,
"precip":0
},
{
"date":"2017-05-26",
"temp":27,
"precip":0
},
{
"date":"2017-05-27",
"temp":26,
"precip":0
},
{
"date":"2017-05-28",
"temp":29,
"precip":0
},
{
"date":"2017-05-29",
"temp":30.5,
"precip":0
},
{
"date":"2017-05-30",
"temp":31.5,
"precip":0
},
{
"date":"2017-05-31",
"temp":29.5,
"precip":0
},
{
"date":"2017-06-01",
"temp":28,
"precip":0
},
{
"date":"2017-06-02",
"temp":30,
"precip":0
},
{
"date":"2017-06-03",
"temp":32.5,
"precip":0
},
{
"date":"2017-06-04",
"temp":32,
"precip":0
},
{
"date":"2017-06-05",
"temp":31.5,
"precip":0
},
{
"date":"2017-06-06",
"temp":33,
"precip":0
},
{
"date":"2017-06-07",
"temp":32.5,
"precip":0
},
{
"date":"2017-06-08",
"temp":31.5,
"precip":0
},
{
"date":"2017-06-09",
"temp":31.5,
"precip":0
},
{
"date":"2017-06-10",
"temp":29,
"precip":0
},
{
"date":"2017-06-11",
"temp":26,
"precip":0
},
{
"date":"2017-06-12",
"temp":21,
"precip":0
},
{
"date":"2017-06-13",
"temp":25,
"precip":0
},
{
"date":"2017-06-14",
"temp":30.5,
"precip":0
},
{
"date":"2017-06-15",
"temp":32,
"precip":0
},
{
"date":"2017-06-16",
"temp":34.5,
"precip":0
},
{
"date":"2017-06-17",
"temp":36,
"precip":0
},
{
"date":"2017-06-18",
"temp":36,
"precip":0
},
{
"date":"2017-06-19",
"temp":37.5,
"precip":0
},
{
"date":"2017-06-20",
"temp":39,
"precip":0
},
{
"date":"2017-06-21",
"temp":38,
"precip":0
},
{
"date":"2017-06-22",
"temp":37.5,
"precip":0
},
{
"date":"2017-06-23",
"temp":37,
"precip":0
},
{
"date":"2017-06-24",
"temp":37.5,
"precip":0
},
{
"date":"2017-06-25",
"temp":37,
"precip":0
},
{
"date":"2017-06-26",
"temp":36.5,
"precip":0
},
{
"date":"2017-06-27",
"temp":34,
"precip":0
},
{
"date":"2017-06-28",
"temp":34,
"precip":0
},
{
"date":"2017-06-29",
"temp":37.5,
"precip":0
},
{
"date":"2017-06-30",
"temp":35,
"precip":0
},
{
"date":"2017-07-01",
"temp":37.5,
"precip":0
},
{
"date":"2017-07-02",
"temp":35.5,
"precip":0
},
{
"date":"2017-07-03",
"temp":36.5,
"precip":0
},
{
"date":"2017-07-04",
"temp":37,
"precip":0
},
{
"date":"2017-07-05",
"temp":39,
"precip":0
},
{
"date":"2017-07-06",
"temp":39.5,
"precip":0
},
{
"date":"2017-07-07",
"temp":40,
"precip":0
},
{
"date":"2017-07-08",
"temp":39,
"precip":0
},
{
"date":"2017-07-09",
"temp":36.5,
"precip":0
},
{
"date":"2017-07-10",
"temp":37,
"precip":0
},
{
"date":"2017-07-11",
"temp":36.5,
"precip":0.1
},
{
"date":"2017-07-12",
"temp":36.5,
"precip":0
},
{
"date":"2017-07-13",
"temp":38,
"precip":0
},
{
"date":"2017-07-14",
"temp":39.5,
"precip":0
},
{
"date":"2017-07-15",
"temp":40,
"precip":0
},
{
"date":"2017-07-16",
"temp":38.5,
"precip":0
},
{
"date":"2017-07-17",
"temp":37,
"precip":0
},
{
"date":"2017-07-18",
"temp":37,
"precip":0
},
{
"date":"2017-07-19",
"temp":34,
"precip":0.4
},
{
"date":"2017-07-20",
"temp":34.5,
"precip":0
},
{
"date":"2017-07-21",
"temp":36.5,
"precip":0
},
{
"date":"2017-07-22",
"temp":36.5,
"precip":0
},
{
"date":"2017-07-23",
"temp":38,
"precip":0
},
{
"date":"2017-07-24",
"temp":34,
"precip":0.1
},
{
"date":"2017-07-25",
"temp":34,
"precip":0
},
{
"date":"2017-07-26",
"temp":33.5,
"precip":0.2
},
{
"date":"2017-07-27",
"temp":36,
"precip":0
},
{
"date":"2017-07-28",
"temp":38,
"precip":0
},
{
"date":"2017-07-29",
"temp":36.5,
"precip":0
},
{
"date":"2017-07-30",
"temp":37.5,
"precip":0.1
},
{
"date":"2017-07-31",
"temp":37,
"precip":0
},
{
"date":"2017-08-01",
"temp":37,
"precip":0
},
{
"date":"2017-08-02",
"temp":35.5,
"precip":0.1
},
{
"date":"2017-08-03",
"temp":33.5,
"precip":0.9
},
{
"date":"2017-08-04",
"temp":32,
"precip":0.1
},
{
"date":"2017-08-05",
"temp":33.5,
"precip":0.1
},
{
"date":"2017-08-06",
"temp":34,
"precip":0
},
{
"date":"2017-08-07",
"temp":33.5,
"precip":0
},
{
"date":"2017-08-08",
"temp":35.5,
"precip":0
},
{
"date":"2017-08-09",
"temp":36,
"precip":0
},
{
"date":"2017-08-10",
"temp":35.5,
"precip":0
},
{
"date":"2017-08-11",
"temp":35,
"precip":0
},
{
"date":"2017-08-12",
"temp":35.5,
"precip":0.1
},
{
"date":"2017-08-13",
"temp":34,
"precip":0
},
{
"date":"2017-08-14",
"temp":32.5,
"precip":0
},
{
"date":"2017-08-15",
"temp":30,
"precip":0
},
{
"date":"2017-08-16",
"temp":31,
"precip":0
},
{
"date":"2017-08-17",
"temp":33.5,
"precip":0
},
{
"date":"2017-08-18",
"temp":34.5,
"precip":0
},
{
"date":"2017-08-19",
"temp":34,
"precip":0
},
{
"date":"2017-08-20",
"temp":33,
"precip":0
},
{
"date":"2017-08-21",
"temp":32,
"precip":0
},
{
"date":"2017-08-22",
"temp":32.5,
"precip":0
},
{
"date":"2017-08-23",
"temp":33,
"precip":0
},
{
"date":"2017-08-24",
"temp":33,
"precip":0
},
{
"date":"2017-08-25",
"temp":33.5,
"precip":0
},
{
"date":"2017-08-26",
"temp":36,
"precip":0
},
{
"date":"2017-08-27",
"temp":37,
"precip":0
},
{
"date":"2017-08-28",
"temp":37,
"precip":0
},
{
"date":"2017-08-29",
"temp":36.5,
"precip":0
},
{
"date":"2017-08-30",
"temp":36,
"precip":0.3
},
{
"date":"2017-08-31",
"temp":33.5,
"precip":0.3
},
{
"date":"2017-09-01",
"temp":33.5,
"precip":0
},
{
"date":"2017-09-02",
"temp":34.5,
"precip":0
},
{
"date":"2017-09-03",
"temp":34,
"precip":0.1
},
{
"date":"2017-09-04",
"temp":29.5,
"precip":0
},
{
"date":"2017-09-05",
"temp":33,
"precip":0
},
{
"date":"2017-09-06",
"temp":32,
"precip":0
},
{
"date":"2017-09-07",
"temp":32,
"precip":0
},
{
"date":"2017-09-08",
"temp":28,
"precip":1.7
},
{
"date":"2017-09-09",
"temp":23,
"precip":7.6
},
{
"date":"2017-09-10",
"temp":29,
"precip":0
},
{
"date":"2017-09-11",
"temp":32,
"precip":0
},
{
"date":"2017-09-12",
"temp":31,
"precip":0
},
{
"date":"2017-09-13",
"temp":30.5,
"precip":0
},
{
"date":"2017-09-14",
"temp":26,
"precip":0
},
{
"date":"2017-09-15",
"temp":23.5,
"precip":0
},
{
"date":"2017-09-16",
"temp":24.5,
"precip":0
},
{
"date":"2017-09-17",
"temp":25,
"precip":0
},
{
"date":"2017-09-18",
"temp":26.5,
"precip":0
},
{
"date":"2017-09-19",
"temp":24.5,
"precip":0
},
{
"date":"2017-09-20",
"temp":24.5,
"precip":0
},
{
"date":"2017-09-21",
"temp":20,
"precip":0
},
{
"date":"2017-09-22",
"temp":17,
"precip":0
},
{
"date":"2017-09-23",
"temp":15.5,
"precip":0
},
{
"date":"2017-09-24",
"temp":17.5,
"precip":0
},
{
"date":"2017-09-25",
"temp":18,
"precip":0
},
{
"date":"2017-09-26",
"temp":18.5,
"precip":0
},
{
"date":"2017-09-27",
"temp":21.5,
"precip":0
},
{
"date":"2017-09-28",
"temp":22,
"precip":0
},
{
"date":"2017-09-29",
"temp":24,
"precip":0
},
{
"date":"2017-09-30",
"temp":25,
"precip":0
},
{
"date":"2017-10-01",
"temp":23,
"precip":0
},
{
"date":"2017-10-02",
"temp":18,
"precip":0
},
{
"date":"2017-10-03",
"temp":18.5,
"precip":0
},
{
"date":"2017-10-04",
"temp":18.5,
"precip":0
},
{
"date":"2017-10-05",
"temp":21.5,
"precip":0
},
{
"date":"2017-10-06",
"temp":19.5,
"precip":0
},
{
"date":"2017-10-07",
"temp":23,
"precip":0
},
{
"date":"2017-10-08",
"temp":24,
"precip":0
},
{
"date":"2017-10-09",
"temp":14.5,
"precip":0
},
{
"date":"2017-10-10",
"temp":18,
"precip":0
},
{
"date":"2017-10-11",
"temp":20,
"precip":0
},
{
"date":"2017-10-12",
"temp":20,
"precip":0
},
{
"date":"2017-10-13",
"temp":21,
"precip":0
},
{
"date":"2017-10-14",
"temp":17,
"precip":0
},
{
"date":"2017-10-15",
"temp":18,
"precip":0
},
{
"date":"2017-10-16",
"temp":20.5,
"precip":0
},
{
"date":"2017-10-17",
"temp":21.5,
"precip":0
},
{
"date":"2017-10-18",
"temp":21.5,
"precip":0
},
{
"date":"2017-10-19",
"temp":22.5,
"precip":0
},
{
"date":"2017-10-20",
"temp":18,
"precip":0
},
{
"date":"2017-10-21",
"temp":15,
"precip":0
},
{
"date":"2017-10-22",
"temp":19.5,
"precip":0
},
{
"date":"2017-10-23",
"temp":22,
"precip":0
},
{
"date":"2017-10-24",
"temp":20.5,
"precip":0
},
{
"date":"2017-10-25",
"temp":21,
"precip":0
},
{
"date":"2017-10-26",
"temp":22,
"precip":0
},
{
"date":"2017-10-27",
"temp":20,
"precip":0
},
{
"date":"2017-10-28",
"temp":19.5,
"precip":0
},
{
"date":"2017-10-29",
"temp":21,
"precip":0
},
{
"date":"2017-10-30",
"temp":19.5,
"precip":0
},
{
"date":"2017-10-31",
"temp":17.5,
"precip":0
},
{
"date":"2017-11-01",
"temp":18,
"precip":0
},
{
"date":"2017-11-02",
"temp":15,
"precip":0
},
{
"date":"2017-11-03",
"temp":14.5,
"precip":0
},
{
"date":"2017-11-04",
"temp":16.5,
"precip":0
},
{
"date":"2017-11-05",
"temp":12.5,
"precip":0
},
{
"date":"2017-11-06",
"temp":12,
"precip":0
},
{
"date":"2017-11-07",
"temp":14,
"precip":0
},
{
"date":"2017-11-08",
"temp":14.5,
"precip":0
},
{
"date":"2017-11-09",
"temp":16.5,
"precip":0
},
{
"date":"2017-11-10",
"temp":16,
"precip":0
},
{
"date":"2017-11-11",
"temp":14.5,
"precip":0
},
{
"date":"2017-11-12",
"temp":14.5,
"precip":0
},
{
"date":"2017-11-13",
"temp":16.5,
"precip":0
},
{
"date":"2017-11-14",
"temp":14.5,
"precip":0
},
{
"date":"2017-11-15",
"temp":16.5,
"precip":0
},
{
"date":"2017-11-16",
"temp":15,
"precip":0
},
{
"date":"2017-11-17",
"temp":17,
"precip":0
},
{
"date":"2017-11-18",
"temp":8.5,
"precip":0
},
{
"date":"2017-11-19",
"temp":11,
"precip":0
},
{
"date":"2017-11-20",
"temp":12,
"precip":0
},
{
"date":"2017-11-21",
"temp":15.5,
"precip":0
},
{
"date":"2017-11-22",
"temp":18.5,
"precip":0
},
{
"date":"2017-11-23",
"temp":18.5,
"precip":0
},
{
"date":"2017-11-24",
"temp":18,
"precip":0
},
{
"date":"2017-11-25",
"temp":18.5,
"precip":0
},
{
"date":"2017-11-26",
"temp":17.5,
"precip":0
},
{
"date":"2017-11-27",
"temp":13,
"precip":0
},
{
"date":"2017-11-28",
"temp":10,
"precip":0
},
{
"date":"2017-11-29",
"temp":12.5,
"precip":0
},
{
"date":"2017-11-30",
"temp":11.5,
"precip":0
},
{
"date":"2017-12-01",
"temp":14,
"precip":0
},
{
"date":"2017-12-02",
"temp":13.5,
"precip":0
},
{
"date":"2017-12-03",
"temp":13.5,
"precip":0
},
{
"date":"2017-12-04",
"temp":4.5,
"precip":0
},
{
"date":"2017-12-05",
"temp":5,
"precip":0
},
{
"date":"2017-12-06",
"temp":7,
"precip":0
},
{
"date":"2017-12-07",
"temp":6.5,
"precip":0
},
{
"date":"2017-12-08",
"temp":10,
"precip":0
},
{
"date":"2017-12-09",
"temp":10,
"precip":0
},
{
"date":"2017-12-10",
"temp":10,
"precip":0
},
{
"date":"2017-12-11",
"temp":10.5,
"precip":0
},
{
"date":"2017-12-12",
"temp":12,
"precip":0
},
{
"date":"2017-12-13",
"temp":12.5,
"precip":0
},
{
"date":"2017-12-14",
"temp":9,
"precip":0
},
{
"date":"2017-12-15",
"temp":10,
"precip":0
},
{
"date":"2017-12-16",
"temp":8,
"precip":0
},
{
"date":"2017-12-17",
"temp":6,
"precip":0
},
{
"date":"2017-12-18",
"temp":7.5,
"precip":0
},
{
"date":"2017-12-19",
"temp":9.5,
"precip":0
},
{
"date":"2017-12-20",
"temp":8.5,
"precip":0
},
{
"date":"2017-12-21",
"temp":3,
"precip":0
},
{
"date":"2017-12-22",
"temp":4,
"precip":0
},
{
"date":"2017-12-23",
"temp":6,
"precip":0
},
{
"date":"2017-12-24",
"temp":8,
"precip":0
},
{
"date":"2017-12-25",
"temp":10,
"precip":0
},
{
"date":"2017-12-26",
"temp":11,
"precip":0
},
{
"date":"2017-12-27",
"temp":12,
"precip":0
},
{
"date":"2017-12-28",
"temp":12,
"precip":0
},
{
"date":"2017-12-29",
"temp":13.5,
"precip":0
},
{
"date":"2017-12-30",
"temp":12,
"precip":0
},
{
"date":"2017-12-31",
"temp":11,
"precip":0
}];

DevExtreme v23.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.
Charts

Points Aggregation

Documentation

This demo illustrates the Chart's data aggregation feature using the line, range area, and bar series. The line series shows temperature changes using average, minimum, or maximum temperature values in the selected time interval. The range area series shows the temperature range for the same time interval and uses a custom aggregate function. The bar series illustrates precipitation and is not aggregated.

Backend API
Copy to CodeSandBox
Apply
Reset
import React from 'react'; import Chart, { CommonSeriesSettings, Series, Aggregation, Point, ArgumentAxis, ValueAxis, Title, Font, Legend, Label, Tooltip, } from 'devextreme-react/chart'; import CheckBox from 'devextreme-react/check-box'; import SelectBox from 'devextreme-react/select-box'; import { weatherData, aggregationFunctions, aggregationIntervals, functionLabel, intervalLabel, } from './data.js'; class App extends React.Component { constructor(props) { super(props); this.state = { useAggregation: true, currentFunction: aggregationFunctions[0].func, currentInterval: aggregationIntervals[0].interval, }; this.updateAggregationUsage = this.updateAggregationUsage.bind(this); this.updateInterval = this.updateInterval.bind(this); this.updateMethod = this.updateMethod.bind(this); } render() { return ( <div id="chart-demo"> <Chart id="chart" dataSource={weatherData} > <CommonSeriesSettings argumentField="date" /> <Series axis="precipitation" color="#03a9f4" type="bar" valueField="precipitation" name="Precipitation" /> <Series axis="temperature" color="#ffc0bb" type="rangearea" rangeValue1Field="minTemp" rangeValue2Field="maxTemp" name="Temperature range" > <Aggregation enabled={this.state.useAggregation} calculate={calculateRangeArea} method="custom" /> </Series> <Series axis="temperature" color="#e91e63" valueField="temp" name="Average temperature" > <Point size={7} /> <Aggregation enabled={this.state.useAggregation} method={this.state.currentFunction} /> </Series> <ArgumentAxis aggregationInterval={this.state.currentInterval} valueMarginsEnabled={false} argumentType="datetime" /> <ValueAxis name="temperature"> <Title text="Temperature, °C"> <Font color="#e91e63" /> </Title> <Label> <Font color="#e91e63" /> </Label> </ValueAxis> <ValueAxis name="precipitation" position="right" > <Title text="Precipitation, mm"> <Font color="#03a9f4" /> </Title> <Label> <Font color="#03a9f4" /> </Label> </ValueAxis> <Legend visible={false} /> <Tooltip enabled={true} customizeTooltip={customizeTooltip} /> <Title text="Weather in Las Vegas, NV (2017)" /> </Chart> <div className="options"> <div className="caption">Options</div> <div className="option"> <CheckBox value={this.state.useAggregation} onValueChanged={this.updateAggregationUsage} text="Aggregation enabled" /> </div> <div className="option"> <span>Interval:</span>&nbsp; <SelectBox dataSource={aggregationIntervals} value={this.state.currentInterval} inputAttr={intervalLabel} onValueChanged={this.updateInterval} displayExpr="displayName" valueExpr="interval" /> </div> <div className="option"> <span>Method:</span>&nbsp; <SelectBox dataSource={aggregationFunctions} inputAttr={functionLabel} value={this.state.currentFunction} onValueChanged={this.updateMethod} displayExpr="displayName" valueExpr="func" /> </div> </div> </div> ); } updateAggregationUsage({ value }) { this.setState({ useAggregation: value }); } updateInterval({ value }) { this.setState({ currentInterval: value }); } updateMethod({ value }) { this.setState({ currentFunction: value }); } } function calculateRangeArea(aggregationInfo) { if (!aggregationInfo.data.length) { return null; } const temp = aggregationInfo.data.map((item) => item.temp); return { date: new Date((aggregationInfo.intervalStart.valueOf() + aggregationInfo.intervalEnd.valueOf()) / 2), maxTemp: Math.max.apply(null, temp), minTemp: Math.min.apply(null, temp), }; } function customizeTooltip(pointInfo) { const { aggregationInfo } = pointInfo.point; const start = aggregationInfo && aggregationInfo.intervalStart; const end = aggregationInfo && aggregationInfo.intervalEnd; const handlers = { 'Average temperature': (arg) => ({ text: `${(!aggregationInfo ? `Date: ${arg.argument.toDateString()}` : `Interval: ${start.toDateString()} - ${end.toDateString()}`) }<br/>Temperature: ${arg.value.toFixed(2)} °C`, }), 'Temperature range': (arg) => ({ text: `Interval: ${start.toDateString() } - ${end.toDateString() }<br/>Temperature range: ${arg.rangeValue1 } - ${arg.rangeValue2} °C`, }), Precipitation: (arg) => ({ text: `Date: ${arg.argument.toDateString() }<br/>Precipitation: ${arg.valueText} mm`, }), }; return handlers[pointInfo.seriesName](pointInfo); } export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render( <App />, document.getElementById('app'), );
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.js"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#chart-demo { height: 700px; } #chart { height: 500px; margin: 0 0 15px; } .options { padding: 20px; margin-top: 20px; background-color: rgba(191, 191, 191, 0.15); } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; } .option > span { width: 50px; display: inline-block; margin-right: 10px; } .option > .dx-selectbox { display: inline-block; vertical-align: middle; }
export const aggregationIntervals = [ { displayName: 'One week', interval: 'week' }, { displayName: 'Two weeks', interval: { weeks: 2 } }, { displayName: 'Month', interval: 'month' }, ]; export const aggregationFunctions = [ { displayName: 'Average', func: 'avg' }, { displayName: 'Minimum', func: 'min' }, { displayName: 'Maximum', func: 'max' }, ]; export const weatherData = [{ date: '2017-01-01', temp: 9.5, precipitation: 0.1, }, { date: '2017-01-02', temp: 8, precipitation: 0.4, }, { date: '2017-01-03', temp: 7.5, precipitation: 0.2, }, { date: '2017-01-04', temp: 8.5, precipitation: 0.1, }, { date: '2017-01-05', temp: 10, precipitation: 0.3, }, { date: '2017-01-06', temp: 3, precipitation: 0, }, { date: '2017-01-07', temp: 5, precipitation: 0.3, }, { date: '2017-01-08', temp: 9.5, precipitation: 0, }, { date: '2017-01-09', temp: 11, precipitation: 0.5, }, { date: '2017-01-10', temp: 8, precipitation: 0, }, { date: '2017-01-11', temp: 11.5, precipitation: 0.3, }, { date: '2017-01-12', temp: 9.5, precipitation: 2.1, }, { date: '2017-01-13', temp: 11.5, precipitation: 3.5, }, { date: '2017-01-14', temp: 11, precipitation: 0.1, }, { date: '2017-01-15', temp: 10.5, precipitation: 0, }, { date: '2017-01-16', temp: 6.5, precipitation: 0, }, { date: '2017-01-17', temp: 7.5, precipitation: 0, }, { date: '2017-01-18', temp: 8, precipitation: 0.1, }, { date: '2017-01-19', temp: 8.5, precipitation: 1.3, }, { date: '2017-01-20', temp: 5.5, precipitation: 5.3, }, { date: '2017-01-21', temp: 9, precipitation: 0.1, }, { date: '2017-01-22', temp: 6, precipitation: 16.6, }, { date: '2017-01-23', temp: 8.5, precipitation: 5.5, }, { date: '2017-01-24', temp: 6.5, precipitation: 1.3, }, { date: '2017-01-25', temp: 4.5, precipitation: 0, }, { date: '2017-01-26', temp: 5.5, precipitation: 0, }, { date: '2017-01-27', temp: 3, precipitation: 0, }, { date: '2017-01-28', temp: 6.5, precipitation: 0, }, { date: '2017-01-29', temp: 8, precipitation: 0, }, { date: '2017-01-30', temp: 10.5, precipitation: 0, }, { date: '2017-01-31', temp: 13, precipitation: 0, }, { date: '2017-02-01', temp: 10.5, precipitation: 0, }, { date: '2017-02-02', temp: 12, precipitation: 0, }, { date: '2017-02-03', temp: 13, precipitation: 0.2, }, { date: '2017-02-04', temp: 10, precipitation: 0, }, { date: '2017-02-05', temp: 11.5, precipitation: 0, }, { date: '2017-02-06', temp: 11.5, precipitation: 0.1, }, { date: '2017-02-07', temp: 12.5, precipitation: 0.5, }, { date: '2017-02-08', temp: 13, precipitation: 0, }, { date: '2017-02-09', temp: 15.5, precipitation: 0, }, { date: '2017-02-10', temp: 16.5, precipitation: 0.1, }, { date: '2017-02-11', temp: 14.5, precipitation: 0.8, }, { date: '2017-02-12', temp: 13.5, precipitation: 0.1, }, { date: '2017-02-13', temp: 13.5, precipitation: 0, }, { date: '2017-02-14', temp: 12, precipitation: 0, }, { date: '2017-02-15', temp: 13.5, precipitation: 0, }, { date: '2017-02-16', temp: 14.5, precipitation: 0, }, { date: '2017-02-17', temp: 12.5, precipitation: 4.5, }, { date: '2017-02-18', temp: 10, precipitation: 14.4, }, { date: '2017-02-19', temp: 13.5, precipitation: 0.5, }, { date: '2017-02-20', temp: 14, precipitation: 0.6, }, { date: '2017-02-21', temp: 15, precipitation: 0, }, { date: '2017-02-22', temp: 11, precipitation: 0, }, { date: '2017-02-23', temp: 7.5, precipitation: 0, }, { date: '2017-02-24', temp: 6, precipitation: 0, }, { date: '2017-02-25', temp: 7, precipitation: 0, }, { date: '2017-02-26', temp: 8, precipitation: 0, }, { date: '2017-02-27', temp: 8.5, precipitation: 0.1, }, { date: '2017-02-28', temp: 10, precipitation: 0, }, { date: '2017-03-01', temp: 9, precipitation: 0, }, { date: '2017-03-02', temp: 11, precipitation: 0, }, { date: '2017-03-03', temp: 15, precipitation: 0, }, { date: '2017-03-04', temp: 14.5, precipitation: 0, }, { date: '2017-03-05', temp: 12.5, precipitation: 0, }, { date: '2017-03-06', temp: 7.5, precipitation: 0, }, { date: '2017-03-07', temp: 11, precipitation: 0, }, { date: '2017-03-08', temp: 16, precipitation: 0, }, { date: '2017-03-09', temp: 19.5, precipitation: 0, }, { date: '2017-03-10', temp: 20, precipitation: 0, }, { date: '2017-03-11', temp: 20.5, precipitation: 0, }, { date: '2017-03-12', temp: 21.5, precipitation: 0, }, { date: '2017-03-13', temp: 21.5, precipitation: 0, }, { date: '2017-03-14', temp: 23.5, precipitation: 0, }, { date: '2017-03-15', temp: 23, precipitation: 0, }, { date: '2017-03-16', temp: 23, precipitation: 0, }, { date: '2017-03-17', temp: 22.5, precipitation: 0, }, { date: '2017-03-18', temp: 23.5, precipitation: 0, }, { date: '2017-03-19', temp: 24, precipitation: 0, }, { date: '2017-03-20', temp: 23.5, precipitation: 0, }, { date: '2017-03-21', temp: 22, precipitation: 0, }, { date: '2017-03-22', temp: 18.5, precipitation: 4, }, { date: '2017-03-23', temp: 15, precipitation: 2.4, }, { date: '2017-03-24', temp: 20.5, precipitation: 0, }, { date: '2017-03-25', temp: 19, precipitation: 0, }, { date: '2017-03-26', temp: 18.5, precipitation: 0, }, { date: '2017-03-27', temp: 18, precipitation: 0, }, { date: '2017-03-28', temp: 17, precipitation: 0, }, { date: '2017-03-29', temp: 21, precipitation: 0, }, { date: '2017-03-30', temp: 19.5, precipitation: 0, }, { date: '2017-03-31', temp: 16.5, precipitation: 0.2, }, { date: '2017-04-01', temp: 19, precipitation: 0, }, { date: '2017-04-02', temp: 20, precipitation: 0, }, { date: '2017-04-03', temp: 18, precipitation: 0, }, { date: '2017-04-04', temp: 16.5, precipitation: 0, }, { date: '2017-04-05', temp: 17, precipitation: 0, }, { date: '2017-04-06', temp: 21.5, precipitation: 0, }, { date: '2017-04-07', temp: 22, precipitation: 0, }, { date: '2017-04-08', temp: 19, precipitation: 0.2, }, { date: '2017-04-09', temp: 14.5, precipitation: 0, }, { date: '2017-04-10', temp: 17, precipitation: 0, }, { date: '2017-04-11', temp: 19.5, precipitation: 0, }, { date: '2017-04-12', temp: 21.5, precipitation: 0, }, { date: '2017-04-13', temp: 21.5, precipitation: 0, }, { date: '2017-04-14', temp: 19, precipitation: 0, }, { date: '2017-04-15', temp: 21, precipitation: 0, }, { date: '2017-04-16', temp: 22.5, precipitation: 0, }, { date: '2017-04-17', temp: 21.5, precipitation: 0, }, { date: '2017-04-18', temp: 21.5, precipitation: 0, }, { date: '2017-04-19', temp: 21.5, precipitation: 0, }, { date: '2017-04-20', temp: 22, precipitation: 0, }, { date: '2017-04-21', temp: 20, precipitation: 0, }, { date: '2017-04-22', temp: 23, precipitation: 0, }, { date: '2017-04-23', temp: 26, precipitation: 0, }, { date: '2017-04-24', temp: 25, precipitation: 0, }, { date: '2017-04-25', temp: 22, precipitation: 0, }, { date: '2017-04-26', temp: 23.5, precipitation: 0, }, { date: '2017-04-27', temp: 23, precipitation: 0, }, { date: '2017-04-28', temp: 19, precipitation: 0, }, { date: '2017-04-29', temp: 19.5, precipitation: 0, }, { date: '2017-04-30', temp: 21.5, precipitation: 0, }, { date: '2017-05-01', temp: 26, precipitation: 0, }, { date: '2017-05-02', temp: 26, precipitation: 0, }, { date: '2017-05-03', temp: 25.5, precipitation: 0, }, { date: '2017-05-04', temp: 28, precipitation: 0, }, { date: '2017-05-05', temp: 28.5, precipitation: 0, }, { date: '2017-05-06', temp: 27, precipitation: 0.4, }, { date: '2017-05-07', temp: 17, precipitation: 0.1, }, { date: '2017-05-08', temp: 17, precipitation: 0, }, { date: '2017-05-09', temp: 20, precipitation: 1.7, }, { date: '2017-05-10', temp: 19.5, precipitation: 0.3, }, { date: '2017-05-11', temp: 23, precipitation: 0, }, { date: '2017-05-12', temp: 26, precipitation: 0, }, { date: '2017-05-13', temp: 22.5, precipitation: 0, }, { date: '2017-05-14', temp: 23, precipitation: 0, }, { date: '2017-05-15', temp: 19.5, precipitation: 0, }, { date: '2017-05-16', temp: 20, precipitation: 0, }, { date: '2017-05-17', temp: 18.5, precipitation: 0, }, { date: '2017-05-18', temp: 19.5, precipitation: 0, }, { date: '2017-05-19', temp: 21.5, precipitation: 0, }, { date: '2017-05-20', temp: 24, precipitation: 0, }, { date: '2017-05-21', temp: 27.5, precipitation: 0, }, { date: '2017-05-22', temp: 29, precipitation: 0, }, { date: '2017-05-23', temp: 30.5, precipitation: 0, }, { date: '2017-05-24', temp: 31, precipitation: 0, }, { date: '2017-05-25', temp: 29.5, precipitation: 0, }, { date: '2017-05-26', temp: 27, precipitation: 0, }, { date: '2017-05-27', temp: 26, precipitation: 0, }, { date: '2017-05-28', temp: 29, precipitation: 0, }, { date: '2017-05-29', temp: 30.5, precipitation: 0, }, { date: '2017-05-30', temp: 31.5, precipitation: 0, }, { date: '2017-05-31', temp: 29.5, precipitation: 0, }, { date: '2017-06-01', temp: 28, precipitation: 0, }, { date: '2017-06-02', temp: 30, precipitation: 0, }, { date: '2017-06-03', temp: 32.5, precipitation: 0, }, { date: '2017-06-04', temp: 32, precipitation: 0, }, { date: '2017-06-05', temp: 31.5, precipitation: 0, }, { date: '2017-06-06', temp: 33, precipitation: 0, }, { date: '2017-06-07', temp: 32.5, precipitation: 0, }, { date: '2017-06-08', temp: 31.5, precipitation: 0, }, { date: '2017-06-09', temp: 31.5, precipitation: 0, }, { date: '2017-06-10', temp: 29, precipitation: 0, }, { date: '2017-06-11', temp: 26, precipitation: 0, }, { date: '2017-06-12', temp: 21, precipitation: 0, }, { date: '2017-06-13', temp: 25, precipitation: 0, }, { date: '2017-06-14', temp: 30.5, precipitation: 0, }, { date: '2017-06-15', temp: 32, precipitation: 0, }, { date: '2017-06-16', temp: 34.5, precipitation: 0, }, { date: '2017-06-17', temp: 36, precipitation: 0, }, { date: '2017-06-18', temp: 36, precipitation: 0, }, { date: '2017-06-19', temp: 37.5, precipitation: 0, }, { date: '2017-06-20', temp: 39, precipitation: 0, }, { date: '2017-06-21', temp: 38, precipitation: 0, }, { date: '2017-06-22', temp: 37.5, precipitation: 0, }, { date: '2017-06-23', temp: 37, precipitation: 0, }, { date: '2017-06-24', temp: 37.5, precipitation: 0, }, { date: '2017-06-25', temp: 37, precipitation: 0, }, { date: '2017-06-26', temp: 36.5, precipitation: 0, }, { date: '2017-06-27', temp: 34, precipitation: 0, }, { date: '2017-06-28', temp: 34, precipitation: 0, }, { date: '2017-06-29', temp: 37.5, precipitation: 0, }, { date: '2017-06-30', temp: 35, precipitation: 0, }, { date: '2017-07-01', temp: 37.5, precipitation: 0, }, { date: '2017-07-02', temp: 35.5, precipitation: 0, }, { date: '2017-07-03', temp: 36.5, precipitation: 0, }, { date: '2017-07-04', temp: 37, precipitation: 0, }, { date: '2017-07-05', temp: 39, precipitation: 0, }, { date: '2017-07-06', temp: 39.5, precipitation: 0, }, { date: '2017-07-07', temp: 40, precipitation: 0, }, { date: '2017-07-08', temp: 39, precipitation: 0, }, { date: '2017-07-09', temp: 36.5, precipitation: 0, }, { date: '2017-07-10', temp: 37, precipitation: 0, }, { date: '2017-07-11', temp: 36.5, precipitation: 0.1, }, { date: '2017-07-12', temp: 36.5, precipitation: 0, }, { date: '2017-07-13', temp: 38, precipitation: 0, }, { date: '2017-07-14', temp: 39.5, precipitation: 0, }, { date: '2017-07-15', temp: 40, precipitation: 0, }, { date: '2017-07-16', temp: 38.5, precipitation: 0, }, { date: '2017-07-17', temp: 37, precipitation: 0, }, { date: '2017-07-18', temp: 37, precipitation: 0, }, { date: '2017-07-19', temp: 34, precipitation: 0.4, }, { date: '2017-07-20', temp: 34.5, precipitation: 0, }, { date: '2017-07-21', temp: 36.5, precipitation: 0, }, { date: '2017-07-22', temp: 36.5, precipitation: 0, }, { date: '2017-07-23', temp: 38, precipitation: 0, }, { date: '2017-07-24', temp: 34, precipitation: 0.1, }, { date: '2017-07-25', temp: 34, precipitation: 0, }, { date: '2017-07-26', temp: 33.5, precipitation: 0.2, }, { date: '2017-07-27', temp: 36, precipitation: 0, }, { date: '2017-07-28', temp: 38, precipitation: 0, }, { date: '2017-07-29', temp: 36.5, precipitation: 0, }, { date: '2017-07-30', temp: 37.5, precipitation: 0.1, }, { date: '2017-07-31', temp: 37, precipitation: 0, }, { date: '2017-08-01', temp: 37, precipitation: 0, }, { date: '2017-08-02', temp: 35.5, precipitation: 0.1, }, { date: '2017-08-03', temp: 33.5, precipitation: 0.9, }, { date: '2017-08-04', temp: 32, precipitation: 0.1, }, { date: '2017-08-05', temp: 33.5, precipitation: 0.1, }, { date: '2017-08-06', temp: 34, precipitation: 0, }, { date: '2017-08-07', temp: 33.5, precipitation: 0, }, { date: '2017-08-08', temp: 35.5, precipitation: 0, }, { date: '2017-08-09', temp: 36, precipitation: 0, }, { date: '2017-08-10', temp: 35.5, precipitation: 0, }, { date: '2017-08-11', temp: 35, precipitation: 0, }, { date: '2017-08-12', temp: 35.5, precipitation: 0.1, }, { date: '2017-08-13', temp: 34, precipitation: 0, }, { date: '2017-08-14', temp: 32.5, precipitation: 0, }, { date: '2017-08-15', temp: 30, precipitation: 0, }, { date: '2017-08-16', temp: 31, precipitation: 0, }, { date: '2017-08-17', temp: 33.5, precipitation: 0, }, { date: '2017-08-18', temp: 34.5, precipitation: 0, }, { date: '2017-08-19', temp: 34, precipitation: 0, }, { date: '2017-08-20', temp: 33, precipitation: 0, }, { date: '2017-08-21', temp: 32, precipitation: 0, }, { date: '2017-08-22', temp: 32.5, precipitation: 0, }, { date: '2017-08-23', temp: 33, precipitation: 0, }, { date: '2017-08-24', temp: 33, precipitation: 0, }, { date: '2017-08-25', temp: 33.5, precipitation: 0, }, { date: '2017-08-26', temp: 36, precipitation: 0, }, { date: '2017-08-27', temp: 37, precipitation: 0, }, { date: '2017-08-28', temp: 37, precipitation: 0, }, { date: '2017-08-29', temp: 36.5, precipitation: 0, }, { date: '2017-08-30', temp: 36, precipitation: 0.3, }, { date: '2017-08-31', temp: 33.5, precipitation: 0.3, }, { date: '2017-09-01', temp: 33.5, precipitation: 0, }, { date: '2017-09-02', temp: 34.5, precipitation: 0, }, { date: '2017-09-03', temp: 34, precipitation: 0.1, }, { date: '2017-09-04', temp: 29.5, precipitation: 0, }, { date: '2017-09-05', temp: 33, precipitation: 0, }, { date: '2017-09-06', temp: 32, precipitation: 0, }, { date: '2017-09-07', temp: 32, precipitation: 0, }, { date: '2017-09-08', temp: 28, precipitation: 1.7, }, { date: '2017-09-09', temp: 23, precipitation: 7.6, }, { date: '2017-09-10', temp: 29, precipitation: 0, }, { date: '2017-09-11', temp: 32, precipitation: 0, }, { date: '2017-09-12', temp: 31, precipitation: 0, }, { date: '2017-09-13', temp: 30.5, precipitation: 0, }, { date: '2017-09-14', temp: 26, precipitation: 0, }, { date: '2017-09-15', temp: 23.5, precipitation: 0, }, { date: '2017-09-16', temp: 24.5, precipitation: 0, }, { date: '2017-09-17', temp: 25, precipitation: 0, }, { date: '2017-09-18', temp: 26.5, precipitation: 0, }, { date: '2017-09-19', temp: 24.5, precipitation: 0, }, { date: '2017-09-20', temp: 24.5, precipitation: 0, }, { date: '2017-09-21', temp: 20, precipitation: 0, }, { date: '2017-09-22', temp: 17, precipitation: 0, }, { date: '2017-09-23', temp: 15.5, precipitation: 0, }, { date: '2017-09-24', temp: 17.5, precipitation: 0, }, { date: '2017-09-25', temp: 18, precipitation: 0, }, { date: '2017-09-26', temp: 18.5, precipitation: 0, }, { date: '2017-09-27', temp: 21.5, precipitation: 0, }, { date: '2017-09-28', temp: 22, precipitation: 0, }, { date: '2017-09-29', temp: 24, precipitation: 0, }, { date: '2017-09-30', temp: 25, precipitation: 0, }, { date: '2017-10-01', temp: 23, precipitation: 0, }, { date: '2017-10-02', temp: 18, precipitation: 0, }, { date: '2017-10-03', temp: 18.5, precipitation: 0, }, { date: '2017-10-04', temp: 18.5, precipitation: 0, }, { date: '2017-10-05', temp: 21.5, precipitation: 0, }, { date: '2017-10-06', temp: 19.5, precipitation: 0, }, { date: '2017-10-07', temp: 23, precipitation: 0, }, { date: '2017-10-08', temp: 24, precipitation: 0, }, { date: '2017-10-09', temp: 14.5, precipitation: 0, }, { date: '2017-10-10', temp: 18, precipitation: 0, }, { date: '2017-10-11', temp: 20, precipitation: 0, }, { date: '2017-10-12', temp: 20, precipitation: 0, }, { date: '2017-10-13', temp: 21, precipitation: 0, }, { date: '2017-10-14', temp: 17, precipitation: 0, }, { date: '2017-10-15', temp: 18, precipitation: 0, }, { date: '2017-10-16', temp: 20.5, precipitation: 0, }, { date: '2017-10-17', temp: 21.5, precipitation: 0, }, { date: '2017-10-18', temp: 21.5, precipitation: 0, }, { date: '2017-10-19', temp: 22.5, precipitation: 0, }, { date: '2017-10-20', temp: 18, precipitation: 0, }, { date: '2017-10-21', temp: 15, precipitation: 0, }, { date: '2017-10-22', temp: 19.5, precipitation: 0, }, { date: '2017-10-23', temp: 22, precipitation: 0, }, { date: '2017-10-24', temp: 20.5, precipitation: 0, }, { date: '2017-10-25', temp: 21, precipitation: 0, }, { date: '2017-10-26', temp: 22, precipitation: 0, }, { date: '2017-10-27', temp: 20, precipitation: 0, }, { date: '2017-10-28', temp: 19.5, precipitation: 0, }, { date: '2017-10-29', temp: 21, precipitation: 0, }, { date: '2017-10-30', temp: 19.5, precipitation: 0, }, { date: '2017-10-31', temp: 17.5, precipitation: 0, }, { date: '2017-11-01', temp: 18, precipitation: 0, }, { date: '2017-11-02', temp: 15, precipitation: 0, }, { date: '2017-11-03', temp: 14.5, precipitation: 0, }, { date: '2017-11-04', temp: 16.5, precipitation: 0, }, { date: '2017-11-05', temp: 12.5, precipitation: 0, }, { date: '2017-11-06', temp: 12, precipitation: 0, }, { date: '2017-11-07', temp: 14, precipitation: 0, }, { date: '2017-11-08', temp: 14.5, precipitation: 0, }, { date: '2017-11-09', temp: 16.5, precipitation: 0, }, { date: '2017-11-10', temp: 16, precipitation: 0, }, { date: '2017-11-11', temp: 14.5, precipitation: 0, }, { date: '2017-11-12', temp: 14.5, precipitation: 0, }, { date: '2017-11-13', temp: 16.5, precipitation: 0, }, { date: '2017-11-14', temp: 14.5, precipitation: 0, }, { date: '2017-11-15', temp: 16.5, precipitation: 0, }, { date: '2017-11-16', temp: 15, precipitation: 0, }, { date: '2017-11-17', temp: 17, precipitation: 0, }, { date: '2017-11-18', temp: 8.5, precipitation: 0, }, { date: '2017-11-19', temp: 11, precipitation: 0, }, { date: '2017-11-20', temp: 12, precipitation: 0, }, { date: '2017-11-21', temp: 15.5, precipitation: 0, }, { date: '2017-11-22', temp: 18.5, precipitation: 0, }, { date: '2017-11-23', temp: 18.5, precipitation: 0, }, { date: '2017-11-24', temp: 18, precipitation: 0, }, { date: '2017-11-25', temp: 18.5, precipitation: 0, }, { date: '2017-11-26', temp: 17.5, precipitation: 0, }, { date: '2017-11-27', temp: 13, precipitation: 0, }, { date: '2017-11-28', temp: 10, precipitation: 0, }, { date: '2017-11-29', temp: 12.5, precipitation: 0, }, { date: '2017-11-30', temp: 11.5, precipitation: 0, }, { date: '2017-12-01', temp: 14, precipitation: 0, }, { date: '2017-12-02', temp: 13.5, precipitation: 0, }, { date: '2017-12-03', temp: 13.5, precipitation: 0, }, { date: '2017-12-04', temp: 4.5, precipitation: 0, }, { date: '2017-12-05', temp: 5, precipitation: 0, }, { date: '2017-12-06', temp: 7, precipitation: 0, }, { date: '2017-12-07', temp: 6.5, precipitation: 0, }, { date: '2017-12-08', temp: 10, precipitation: 0, }, { date: '2017-12-09', temp: 10, precipitation: 0, }, { date: '2017-12-10', temp: 10, precipitation: 0, }, { date: '2017-12-11', temp: 10.5, precipitation: 0, }, { date: '2017-12-12', temp: 12, precipitation: 0, }, { date: '2017-12-13', temp: 12.5, precipitation: 0, }, { date: '2017-12-14', temp: 9, precipitation: 0, }, { date: '2017-12-15', temp: 10, precipitation: 0, }, { date: '2017-12-16', temp: 8, precipitation: 0, }, { date: '2017-12-17', temp: 6, precipitation: 0, }, { date: '2017-12-18', temp: 7.5, precipitation: 0, }, { date: '2017-12-19', temp: 9.5, precipitation: 0, }, { date: '2017-12-20', temp: 8.5, precipitation: 0, }, { date: '2017-12-21', temp: 3, precipitation: 0, }, { date: '2017-12-22', temp: 4, precipitation: 0, }, { date: '2017-12-23', temp: 6, precipitation: 0, }, { date: '2017-12-24', temp: 8, precipitation: 0, }, { date: '2017-12-25', temp: 10, precipitation: 0, }, { date: '2017-12-26', temp: 11, precipitation: 0, }, { date: '2017-12-27', temp: 12, precipitation: 0, }, { date: '2017-12-28', temp: 12, precipitation: 0, }, { date: '2017-12-29', temp: 13.5, precipitation: 0, }, { date: '2017-12-30', temp: 12, precipitation: 0, }, { date: '2017-12-31', temp: 11, precipitation: 0, }]; export const intervalLabel = { 'aria-label': 'Interval' }; export const functionLabel = { 'aria-label': 'Function' };
window.config = { transpiler: 'plugin-babel', meta: { 'devextreme/localization.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, defaultExtension: 'js', map: { 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types@15.8.1/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.1.5/cjs', 'devextreme-react': 'npm:devextreme-react@23.1.5', 'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.1/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.48/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.11/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config);

<div id="chart-demo">
<dx-chart
id="chart"
title="Weather in Las Vegas, NV (2017)"
[dataSource]="weatherIndicators">
<dxo-common-series-settings
argumentField="date">
</dxo-common-series-settings>
<dxi-series
axis="precipitation"
color="#03a9f4"
type="bar"
valueField="precip"
name="Precipitation">
</dxi-series>
<dxi-series
axis="temperature"
color= "#ffc0bb"
type="rangeArea"
rangeValue1Field="minTemp"
rangeValue2Field="maxTemp"
name="Temperature range">
<dxo-aggregation
[enabled]="useAggregation"
method="custom"
[calculate]="calculateRangeArea">
</dxo-aggregation>
</dxi-series>
<dxi-series
axis="temperature"
color="#e91e63"
valueField="temp"
name="Average temperature">
<dxo-point [size]="7"></dxo-point>
<dxo-aggregation #pointsAggregationSettings
[enabled]="useAggregation"
method="avg">
</dxo-aggregation>
</dxi-series>
<dxo-argument-axis #argumentAxisSettings
argumentType="datetime"
aggregationInterval="week"
[valueMarginsEnabled]="false">
</dxo-argument-axis>
<dxi-value-axis
name="temperature">
<dxo-title text="Temperature, °C">
<dxo-font color="#e91e63"></dxo-font>
</dxo-title>
<dxo-label>
<dxo-font color="#e91e63"></dxo-font>
</dxo-label>
</dxi-value-axis>
<dxi-value-axis
name="precipitation"
position="right">
<dxo-title text="Precipitation, mm">
<dxo-font color="#03a9f4"></dxo-font>
</dxo-title>
<dxo-label>
<dxo-font color="#03a9f4"></dxo-font>
</dxo-label>
</dxi-value-axis>
<dxo-legend [visible]="false"></dxo-legend>
<dxo-tooltip
[enabled]="true"
[customizeTooltip]="customizeTooltip">
</dxo-tooltip>
</dx-chart>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
text="Aggregation enabled"
[(value)]="useAggregation">
</dx-check-box>
</div>
<div class="option">
<span>Interval:</span>
<dx-select-box
[dataSource]="intervals"
displayExpr="displayName"
valueExpr="interval"
[(value)]="argumentAxisSettings.aggregationInterval">
</dx-select-box>
</div>
<div class="option">
<span>Method:</span>
<dx-select-box
[dataSource]="functions"
displayExpr="displayName"
valueExpr="func"
[(value)]="pointsAggregationSettings.method">
</dx-select-box>
</div>
</div>
</div>
import { NgModule, Component, ViewChild, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxChartModule, DxSelectBoxModule, DxCheckBoxModule } from 'devextreme-angular';
import { Service, WeatherIndicators, AggregationInterval, AggregationFunction } from './app.service';
if(!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
preserveWhitespaces: true
})
export class AppComponent {
weatherIndicators: WeatherIndicators[];
intervals: AggregationInterval[];
functions: AggregationFunction[];
useAggregation: Boolean = true;
constructor(service: Service) {
this.weatherIndicators = service.getWeatherIndicators();
this.intervals = service.getAggregationIntervals();
this.functions = service.getAggregationFunctions();
}
customizeTooltip(arg: any) {
let aggregationInfo = arg.point.aggregationInfo,
start = aggregationInfo && aggregationInfo.intervalStart,
end = aggregationInfo && aggregationInfo.intervalEnd;
if(arg.seriesName === "Average temperature") {
return {
text: (!aggregationInfo ?
"Date: " + arg.argument.toDateString() :
"Interval: " + start.toDateString() +
" - " + end.toDateString()) +
"<br/>Temperature: " + arg.value.toFixed(2) + " °C"
};
} else if(arg.seriesName === "Temperature range") {
return {
text: "Interval: " + start.toDateString() +
" - " + end.toDateString() +
"<br/>Temperature range: " + arg.rangeValue1 +
" - " + arg.rangeValue2 + " °C"
};
} else if(arg.seriesName === "Precipitation") {
return {
text: "Date: " + arg.argument.toDateString() +
"<br/>Precipitation: " + arg.valueText + " mm"
};
}
}
calculateRangeArea(aggregationInfo:any, series:any) {
if(!aggregationInfo.data.length) {
return;
}
let temp = aggregationInfo.data.map(function(item) { return item.temp; }),
maxTemp = Math.max.apply(null, temp),
minTemp = Math.min.apply(null, temp);
return {
date: aggregationInfo.intervalStart,
maxTemp: maxTemp,
minTemp: minTemp
};
}
}
@NgModule({
imports: [
BrowserModule,
DxChartModule,
DxSelectBoxModule,
DxCheckBoxModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #chart-demo {
height: 700px;
width: 100%;
}
::ng-deep #chart {
height: 500px;
margin: 0 0 15px;
}
::ng-deep .options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
::ng-deep .caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .option {
margin-top: 10px;
}
::ng-deep .option > span {
width: 50px;
display: inline-block;
margin-right: 10px;
}
::ng-deep .option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export class WeatherIndicators {
date: string;
temp: number;
precip: number;
}
export class AggregationInterval {
displayName: string;
interval: any;
}
export class AggregationFunction {
displayName: string;
func: string;
}
let intervals: AggregationInterval[] = [{
displayName: "One week",
interval: "week"
}, {
displayName: "Two weeks",
interval: { weeks: 2 }
}, {
displayName: "Month",
interval: "month"
}];
let functions: AggregationFunction[] = [{
displayName: "Average",
func: "avg"
}, {
displayName: "Minimum",
func: "min"
}, {
displayName: "Maximum",
func: "max"
}];
let weatherIndicators: WeatherIndicators[] = [{
date:"2017-01-01",
temp:9.5,
precip:0.1
},
{
date:"2017-01-02",
temp:8,
precip:0.4
},
{
date:"2017-01-03",
temp:7.5,
precip:0.2
},
{
date:"2017-01-04",
temp:8.5,
precip:0.1
},
{
date:"2017-01-05",
temp:10,
precip:0.3
},
{
date:"2017-01-06",
temp:3,
precip:0
},
{
date:"2017-01-07",
temp:5,
precip:0.3
},
{
date:"2017-01-08",
temp:9.5,
precip:0
},
{
date:"2017-01-09",
temp:11,
precip:0.5
},
{
date:"2017-01-10",
temp:8,
precip:0
},
{
date:"2017-01-11",
temp:11.5,
precip:0.3
},
{
date:"2017-01-12",
temp:9.5,
precip:2.1
},
{
date:"2017-01-13",
temp:11.5,
precip:3.5
},
{
date:"2017-01-14",
temp:11,
precip:0.1
},
{
date:"2017-01-15",
temp:10.5,
precip:0
},
{
date:"2017-01-16",
temp:6.5,
precip:0
},
{
date:"2017-01-17",
temp:7.5,
precip:0
},
{
date:"2017-01-18",
temp:8,
precip:0.1
},
{
date:"2017-01-19",
temp:8.5,
precip:1.3
},
{
date:"2017-01-20",
temp:5.5,
precip:5.3
},
{
date:"2017-01-21",
temp:9,
precip:0.1
},
{
date:"2017-01-22",
temp:6,
precip:16.6
},
{
date:"2017-01-23",
temp:8.5,
precip:5.5
},
{
date:"2017-01-24",
temp:6.5,
precip:1.3
},
{
date:"2017-01-25",
temp:4.5,
precip:0
},
{
date:"2017-01-26",
temp:5.5,
precip:0
},
{
date:"2017-01-27",
temp:3,
precip:0
},
{
date:"2017-01-28",
temp:6.5,
precip:0
},
{
date:"2017-01-29",
temp:8,
precip:0
},
{
date:"2017-01-30",
temp:10.5,
precip:0
},
{
date:"2017-01-31",
temp:13,
precip:0
},
{
date:"2017-02-01",
temp:10.5,
precip:0
},
{
date:"2017-02-02",
temp:12,
precip:0
},
{
date:"2017-02-03",
temp:13,
precip:0.2
},
{
date:"2017-02-04",
temp:10,
precip:0
},
{
date:"2017-02-05",
temp:11.5,
precip:0
},
{
date:"2017-02-06",
temp:11.5,
precip:0.1
},
{
date:"2017-02-07",
temp:12.5,
precip:0.5
},
{
date:"2017-02-08",
temp:13,
precip:0
},
{
date:"2017-02-09",
temp:15.5,
precip:0
},
{
date:"2017-02-10",
temp:16.5,
precip:0.1
},
{
date:"2017-02-11",
temp:14.5,
precip:0.8
},
{
date:"2017-02-12",
temp:13.5,
precip:0.1
},
{
date:"2017-02-13",
temp:13.5,
precip:0
},
{
date:"2017-02-14",
temp:12,
precip:0
},
{
date:"2017-02-15",
temp:13.5,
precip:0
},
{
date:"2017-02-16",
temp:14.5,
precip:0
},
{
date:"2017-02-17",
temp:12.5,
precip:4.5
},
{
date:"2017-02-18",
temp:10,
precip:14.4
},
{
date:"2017-02-19",
temp:13.5,
precip:0.5
},
{
date:"2017-02-20",
temp:14,
precip:0.6
},
{
date:"2017-02-21",
temp:15,
precip:0
},
{
date:"2017-02-22",
temp:11,
precip:0
},
{
date:"2017-02-23",
temp:7.5,
precip:0
},
{
date:"2017-02-24",
temp:6,
precip:0
},
{
date:"2017-02-25",
temp:7,
precip:0
},
{
date:"2017-02-26",
temp:8,
precip:0
},
{
date:"2017-02-27",
temp:8.5,
precip:0.1
},
{
date:"2017-02-28",
temp:10,
precip:0
},
{
date:"2017-03-01",
temp:9,
precip:0
},
{
date:"2017-03-02",
temp:11,
precip:0
},
{
date:"2017-03-03",
temp:15,
precip:0
},
{
date:"2017-03-04",
temp:14.5,
precip:0
},
{
date:"2017-03-05",
temp:12.5,
precip:0
},
{
date:"2017-03-06",
temp:7.5,
precip:0
},
{
date:"2017-03-07",
temp:11,
precip:0
},
{
date:"2017-03-08",
temp:16,
precip:0
},
{
date:"2017-03-09",
temp:19.5,
precip:0
},
{
date:"2017-03-10",
temp:20,
precip:0
},
{
date:"2017-03-11",
temp:20.5,
precip:0
},
{
date:"2017-03-12",
temp:21.5,
precip:0
},
{
date:"2017-03-13",
temp:21.5,
precip:0
},
{
date:"2017-03-14",
temp:23.5,
precip:0
},
{
date:"2017-03-15",
temp:23,
precip:0
},
{
date:"2017-03-16",
temp:23,
precip:0
},
{
date:"2017-03-17",
temp:22.5,
precip:0
},
{
date:"2017-03-18",
temp:23.5,
precip:0
},
{
date:"2017-03-19",
temp:24,
precip:0
},
{
date:"2017-03-20",
temp:23.5,
precip:0
},
{
date:"2017-03-21",
temp:22,
precip:0
},
{
date:"2017-03-22",
temp:18.5,
precip:4
},
{
date:"2017-03-23",
temp:15,
precip:2.4
},
{
date:"2017-03-24",
temp:20.5,
precip:0
},
{
date:"2017-03-25",
temp:19,
precip:0
},
{
date:"2017-03-26",
temp:18.5,
precip:0
},
{
date:"2017-03-27",
temp:18,
precip:0
},
{
date:"2017-03-28",
temp:17,
precip:0
},
{
date:"2017-03-29",
temp:21,
precip:0
},
{
date:"2017-03-30",
temp:19.5,
precip:0
},
{
date:"2017-03-31",
temp:16.5,
precip:0.2
},
{
date:"2017-04-01",
temp:19,
precip:0
},
{
date:"2017-04-02",
temp:20,
precip:0
},
{
date:"2017-04-03",
temp:18,
precip:0
},
{
date:"2017-04-04",
temp:16.5,
precip:0
},
{
date:"2017-04-05",
temp:17,
precip:0
},
{
date:"2017-04-06",
temp:21.5,
precip:0
},
{
date:"2017-04-07",
temp:22,
precip:0
},
{
date:"2017-04-08",
temp:19,
precip:0.2
},
{
date:"2017-04-09",
temp:14.5,
precip:0
},
{
date:"2017-04-10",
temp:17,
precip:0
},
{
date:"2017-04-11",
temp:19.5,
precip:0
},
{
date:"2017-04-12",
temp:21.5,
precip:0
},
{
date:"2017-04-13",
temp:21.5,
precip:0
},
{
date:"2017-04-14",
temp:19,
precip:0
},
{
date:"2017-04-15",
temp:21,
precip:0
},
{
date:"2017-04-16",
temp:22.5,
precip:0
},
{
date:"2017-04-17",
temp:21.5,
precip:0
},
{
date:"2017-04-18",
temp:21.5,
precip:0
},
{
date:"2017-04-19",
temp:21.5,
precip:0
},
{
date:"2017-04-20",
temp:22,
precip:0
},
{
date:"2017-04-21",
temp:20,
precip:0
},
{
date:"2017-04-22",
temp:23,
precip:0
},
{
date:"2017-04-23",
temp:26,
precip:0
},
{
date:"2017-04-24",
temp:25,
precip:0
},
{
date:"2017-04-25",
temp:22,
precip:0
},
{
date:"2017-04-26",
temp:23.5,
precip:0
},
{
date:"2017-04-27",
temp:23,
precip:0
},
{
date:"2017-04-28",
temp:19,
precip:0
},
{
date:"2017-04-29",
temp:19.5,
precip:0
},
{
date:"2017-04-30",
temp:21.5,
precip:0
},
{
date:"2017-05-01",
temp:26,
precip:0
},
{
date:"2017-05-02",
temp:26,
precip:0
},
{
date:"2017-05-03",
temp:25.5,
precip:0
},
{
date:"2017-05-04",
temp:28,
precip:0
},
{
date:"2017-05-05",
temp:28.5,
precip:0
},
{
date:"2017-05-06",
temp:27,
precip:0.4
},
{
date:"2017-05-07",
temp:17,
precip:0.1
},
{
date:"2017-05-08",
temp:17,
precip:0
},
{
date:"2017-05-09",
temp:20,
precip:1.7
},
{
date:"2017-05-10",
temp:19.5,
precip:0.3
},
{
date:"2017-05-11",
temp:23,
precip:0
},
{
date:"2017-05-12",
temp:26,
precip:0
},
{
date:"2017-05-13",
temp:22.5,
precip:0
},
{
date:"2017-05-14",
temp:23,
precip:0
},
{
date:"2017-05-15",
temp:19.5,
precip:0
},
{
date:"2017-05-16",
temp:20,
precip:0
},
{
date:"2017-05-17",
temp:18.5,
precip:0
},
{
date:"2017-05-18",
temp:19.5,
precip:0
},
{
date:"2017-05-19",
temp:21.5,
precip:0
},
{
date:"2017-05-20",
temp:24,
precip:0
},
{
date:"2017-05-21",
temp:27.5,
precip:0
},
{
date:"2017-05-22",
temp:29,
precip:0
},
{
date:"2017-05-23",
temp:30.5,
precip:0
},
{
date:"2017-05-24",
temp:31,
precip:0
},
{
date:"2017-05-25",
temp:29.5,
precip:0
},
{
date:"2017-05-26",
temp:27,
precip:0
},
{
date:"2017-05-27",
temp:26,
precip:0
},
{
date:"2017-05-28",
temp:29,
precip:0
},
{
date:"2017-05-29",
temp:30.5,
precip:0
},
{
date:"2017-05-30",
temp:31.5,
precip:0
},
{
date:"2017-05-31",
temp:29.5,
precip:0
},
{
date:"2017-06-01",
temp:28,
precip:0
},
{
date:"2017-06-02",
temp:30,
precip:0
},
{
date:"2017-06-03",
temp:32.5,
precip:0
},
{
date:"2017-06-04",
temp:32,
precip:0
},
{
date:"2017-06-05",
temp:31.5,
precip:0
},
{
date:"2017-06-06",
temp:33,
precip:0
},
{
date:"2017-06-07",
temp:32.5,
precip:0
},
{
date:"2017-06-08",
temp:31.5,
precip:0
},
{
date:"2017-06-09",
temp:31.5,
precip:0
},
{
date:"2017-06-10",
temp:29,
precip:0
},
{
date:"2017-06-11",
temp:26,
precip:0
},
{
date:"2017-06-12",
temp:21,
precip:0
},
{
date:"2017-06-13",
temp:25,
precip:0
},
{
date:"2017-06-14",
temp:30.5,
precip:0
},
{
date:"2017-06-15",
temp:32,
precip:0
},
{
date:"2017-06-16",
temp:34.5,
precip:0
},
{
date:"2017-06-17",
temp:36,
precip:0
},
{
date:"2017-06-18",
temp:36,
precip:0
},
{
date:"2017-06-19",
temp:37.5,
precip:0
},
{
date:"2017-06-20",
temp:39,
precip:0
},
{
date:"2017-06-21",
temp:38,
precip:0
},
{
date:"2017-06-22",
temp:37.5,
precip:0
},
{
date:"2017-06-23",
temp:37,
precip:0
},
{
date:"2017-06-24",
temp:37.5,
precip:0
},
{
date:"2017-06-25",
temp:37,
precip:0
},
{
date:"2017-06-26",
temp:36.5,
precip:0
},
{
date:"2017-06-27",
temp:34,
precip:0
},
{
date:"2017-06-28",
temp:34,
precip:0
},
{
date:"2017-06-29",
temp:37.5,
precip:0
},
{
date:"2017-06-30",
temp:35,
precip:0
},
{
date:"2017-07-01",
temp:37.5,
precip:0
},
{
date:"2017-07-02",
temp:35.5,
precip:0
},
{
date:"2017-07-03",
temp:36.5,
precip:0
},
{
date:"2017-07-04",
temp:37,
precip:0
},
{
date:"2017-07-05",
temp:39,
precip:0
},
{
date:"2017-07-06",
temp:39.5,
precip:0
},
{
date:"2017-07-07",
temp:40,
precip:0
},
{
date:"2017-07-08",
temp:39,
precip:0
},
{
date:"2017-07-09",
temp:36.5,
precip:0
},
{
date:"2017-07-10",
temp:37,
precip:0
},
{
date:"2017-07-11",
temp:36.5,
precip:0.1
},
{
date:"2017-07-12",
temp:36.5,
precip:0
},
{
date:"2017-07-13",
temp:38,
precip:0
},
{
date:"2017-07-14",
temp:39.5,
precip:0
},
{
date:"2017-07-15",
temp:40,
precip:0
},
{
date:"2017-07-16",
temp:38.5,
precip:0
},
{
date:"2017-07-17",
temp:37,
precip:0
},
{
date:"2017-07-18",
temp:37,
precip:0
},
{
date:"2017-07-19",
temp:34,
precip:0.4
},
{
date:"2017-07-20",
temp:34.5,
precip:0
},
{
date:"2017-07-21",
temp:36.5,
precip:0
},
{
date:"2017-07-22",
temp:36.5,
precip:0
},
{
date:"2017-07-23",
temp:38,
precip:0
},
{
date:"2017-07-24",
temp:34,
precip:0.1
},
{
date:"2017-07-25",
temp:34,
precip:0
},
{
date:"2017-07-26",
temp:33.5,
precip:0.2
},
{
date:"2017-07-27",
temp:36,
precip:0
},
{
date:"2017-07-28",
temp:38,
precip:0
},
{
date:"2017-07-29",
temp:36.5,
precip:0
},
{
date:"2017-07-30",
temp:37.5,
precip:0.1
},
{
date:"2017-07-31",
temp:37,
precip:0
},
{
date:"2017-08-01",
temp:37,
precip:0
},
{
date:"2017-08-02",
temp:35.5,
precip:0.1
},
{
date:"2017-08-03",
temp:33.5,
precip:0.9
},
{
date:"2017-08-04",
temp:32,
precip:0.1
},
{
date:"2017-08-05",
temp:33.5,
precip:0.1
},
{
date:"2017-08-06",
temp:34,
precip:0
},
{
date:"2017-08-07",
temp:33.5,
precip:0
},
{
date:"2017-08-08",
temp:35.5,
precip:0
},
{
date:"2017-08-09",
temp:36,
precip:0
},
{
date:"2017-08-10",
temp:35.5,
precip:0
},
{
date:"2017-08-11",
temp:35,
precip:0
},
{
date:"2017-08-12",
temp:35.5,
precip:0.1
},
{
date:"2017-08-13",
temp:34,
precip:0
},
{
date:"2017-08-14",
temp:32.5,
precip:0
},
{
date:"2017-08-15",
temp:30,
precip:0
},
{
date:"2017-08-16",
temp:31,
precip:0
},
{
date:"2017-08-17",
temp:33.5,
precip:0
},
{
date:"2017-08-18",
temp:34.5,
precip:0
},
{
date:"2017-08-19",
temp:34,
precip:0
},
{
date:"2017-08-20",
temp:33,
precip:0
},
{
date:"2017-08-21",
temp:32,
precip:0
},
{
date:"2017-08-22",
temp:32.5,
precip:0
},
{
date:"2017-08-23",
temp:33,
precip:0
},
{
date:"2017-08-24",
temp:33,
precip:0
},
{
date:"2017-08-25",
temp:33.5,
precip:0
},
{
date:"2017-08-26",
temp:36,
precip:0
},
{
date:"2017-08-27",
temp:37,
precip:0
},
{
date:"2017-08-28",
temp:37,
precip:0
},
{
date:"2017-08-29",
temp:36.5,
precip:0
},
{
date:"2017-08-30",
temp:36,
precip:0.3
},
{
date:"2017-08-31",
temp:33.5,
precip:0.3
},
{
date:"2017-09-01",
temp:33.5,
precip:0
},
{
date:"2017-09-02",
temp:34.5,
precip:0
},
{
date:"2017-09-03",
temp:34,
precip:0.1
},
{
date:"2017-09-04",
temp:29.5,
precip:0
},
{
date:"2017-09-05",
temp:33,
precip:0
},
{
date:"2017-09-06",
temp:32,
precip:0
},
{
date:"2017-09-07",
temp:32,
precip:0
},
{
date:"2017-09-08",
temp:28,
precip:1.7
},
{
date:"2017-09-09",
temp:23,
precip:7.6
},
{
date:"2017-09-10",
temp:29,
precip:0
},
{
date:"2017-09-11",
temp:32,
precip:0
},
{
date:"2017-09-12",
temp:31,
precip:0
},
{
date:"2017-09-13",
temp:30.5,
precip:0
},
{
date:"2017-09-14",
temp:26,
precip:0
},
{
date:"2017-09-15",
temp:23.5,
precip:0
},
{
date:"2017-09-16",
temp:24.5,
precip:0
},
{
date:"2017-09-17",
temp:25,
precip:0
},
{
date:"2017-09-18",
temp:26.5,
precip:0
},
{
date:"2017-09-19",
temp:24.5,
precip:0
},
{
date:"2017-09-20",
temp:24.5,
precip:0
},
{
date:"2017-09-21",
temp:20,
precip:0
},
{
date:"2017-09-22",
temp:17,
precip:0
},
{
date:"2017-09-23",
temp:15.5,
precip:0
},
{
date:"2017-09-24",
temp:17.5,
precip:0
},
{
date:"2017-09-25",
temp:18,
precip:0
},
{
date:"2017-09-26",
temp:18.5,
precip:0
},
{
date:"2017-09-27",
temp:21.5,
precip:0
},
{
date:"2017-09-28",
temp:22,
precip:0
},
{
date:"2017-09-29",
temp:24,
precip:0
},
{
date:"2017-09-30",
temp:25,
precip:0
},
{
date:"2017-10-01",
temp:23,
precip:0
},
{
date:"2017-10-02",
temp:18,
precip:0
},
{
date:"2017-10-03",
temp:18.5,
precip:0
},
{
date:"2017-10-04",
temp:18.5,
precip:0
},
{
date:"2017-10-05",
temp:21.5,
precip:0
},
{
date:"2017-10-06",
temp:19.5,
precip:0
},
{
date:"2017-10-07",
temp:23,
precip:0
},
{
date:"2017-10-08",
temp:24,
precip:0
},
{
date:"2017-10-09",
temp:14.5,
precip:0
},
{
date:"2017-10-10",
temp:18,
precip:0
},
{
date:"2017-10-11",
temp:20,
precip:0
},
{
date:"2017-10-12",
temp:20,
precip:0
},
{
date:"2017-10-13",
temp:21,
precip:0
},
{
date:"2017-10-14",
temp:17,
precip:0
},
{
date:"2017-10-15",
temp:18,
precip:0
},
{
date:"2017-10-16",
temp:20.5,
precip:0
},
{
date:"2017-10-17",
temp:21.5,
precip:0
},
{
date:"2017-10-18",
temp:21.5,
precip:0
},
{
date:"2017-10-19",
temp:22.5,
precip:0
},
{
date:"2017-10-20",
temp:18,
precip:0
},
{
date:"2017-10-21",
temp:15,
precip:0
},
{
date:"2017-10-22",
temp:19.5,
precip:0
},
{
date:"2017-10-23",
temp:22,
precip:0
},
{
date:"2017-10-24",
temp:20.5,
precip:0
},
{
date:"2017-10-25",
temp:21,
precip:0
},
{
date:"2017-10-26",
temp:22,
precip:0
},
{
date:"2017-10-27",
temp:20,
precip:0
},
{
date:"2017-10-28",
temp:19.5,
precip:0
},
{
date:"2017-10-29",
temp:21,
precip:0
},
{
date:"2017-10-30",
temp:19.5,
precip:0
},
{
date:"2017-10-31",
temp:17.5,
precip:0
},
{
date:"2017-11-01",
temp:18,
precip:0
},
{
date:"2017-11-02",
temp:15,
precip:0
},
{
date:"2017-11-03",
temp:14.5,
precip:0
},
{
date:"2017-11-04",
temp:16.5,
precip:0
},
{
date:"2017-11-05",
temp:12.5,
precip:0
},
{
date:"2017-11-06",
temp:12,
precip:0
},
{
date:"2017-11-07",
temp:14,
precip:0
},
{
date:"2017-11-08",
temp:14.5,
precip:0
},
{
date:"2017-11-09",
temp:16.5,
precip:0
},
{
date:"2017-11-10",
temp:16,
precip:0
},
{
date:"2017-11-11",
temp:14.5,
precip:0
},
{
date:"2017-11-12",
temp:14.5,
precip:0
},
{
date:"2017-11-13",
temp:16.5,
precip:0
},
{
date:"2017-11-14",
temp:14.5,
precip:0
},
{
date:"2017-11-15",
temp:16.5,
precip:0
},
{
date:"2017-11-16",
temp:15,
precip:0
},
{
date:"2017-11-17",
temp:17,
precip:0
},
{
date:"2017-11-18",
temp:8.5,
precip:0
},
{
date:"2017-11-19",
temp:11,
precip:0
},
{
date:"2017-11-20",
temp:12,
precip:0
},
{
date:"2017-11-21",
temp:15.5,
precip:0
},
{
date:"2017-11-22",
temp:18.5,
precip:0
},
{
date:"2017-11-23",
temp:18.5,
precip:0
},
{
date:"2017-11-24",
temp:18,
precip:0
},
{
date:"2017-11-25",
temp:18.5,
precip:0
},
{
date:"2017-11-26",
temp:17.5,
precip:0
},
{
date:"2017-11-27",
temp:13,
precip:0
},
{
date:"2017-11-28",
temp:10,
precip:0
},
{
date:"2017-11-29",
temp:12.5,
precip:0
},
{
date:"2017-11-30",
temp:11.5,
precip:0
},
{
date:"2017-12-01",
temp:14,
precip:0
},
{
date:"2017-12-02",
temp:13.5,
precip:0
},
{
date:"2017-12-03",
temp:13.5,
precip:0
},
{
date:"2017-12-04",
temp:4.5,
precip:0
},
{
date:"2017-12-05",
temp:5,
precip:0
},
{
date:"2017-12-06",
temp:7,
precip:0
},
{
date:"2017-12-07",
temp:6.5,
precip:0
},
{
date:"2017-12-08",
temp:10,
precip:0
},
{
date:"2017-12-09",
temp:10,
precip:0
},
{
date:"2017-12-10",
temp:10,
precip:0
},
{
date:"2017-12-11",
temp:10.5,
precip:0
},
{
date:"2017-12-12",
temp:12,
precip:0
},
{
date:"2017-12-13",
temp:12.5,
precip:0
},
{
date:"2017-12-14",
temp:9,
precip:0
},
{
date:"2017-12-15",
temp:10,
precip:0
},
{
date:"2017-12-16",
temp:8,
precip:0
},
{
date:"2017-12-17",
temp:6,
precip:0
},
{
date:"2017-12-18",
temp:7.5,
precip:0
},
{
date:"2017-12-19",
temp:9.5,
precip:0
},
{
date:"2017-12-20",
temp:8.5,
precip:0
},
{
date:"2017-12-21",
temp:3,
precip:0
},
{
date:"2017-12-22",
temp:4,
precip:0
},
{
date:"2017-12-23",
temp:6,
precip:0
},
{
date:"2017-12-24",
temp:8,
precip:0
},
{
date:"2017-12-25",
temp:10,
precip:0
},
{
date:"2017-12-26",
temp:11,
precip:0
},
{
date:"2017-12-27",
temp:12,
precip:0
},
{
date:"2017-12-28",
temp:12,
precip:0
},
{
date:"2017-12-29",
temp:13.5,
precip:0
},
{
date:"2017-12-30",
temp:12,
precip:0
},
{
date:"2017-12-31",
temp:11,
precip:0
}];
@Injectable()
export class Service {
getWeatherIndicators(): WeatherIndicators[] {
return weatherIndicators;
}
getAggregationIntervals(): AggregationInterval[] {
return intervals;
}
getAggregationFunctions(): AggregationFunction[] {
return functions;
}
}
// In real applications, you should not transpile code in the browser. You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
System.config({
transpiler: 'ts',
typescriptOptions: {
module: "system",
emitDecoratorMetadata: true,
experimentalDecorators: true
},
meta: {
'typescript': {
"exports": "ts"
},
'devextreme/localization.js': {
"esModule": true
}
},
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@3.5.3/lib/typescript.js',
'@angular': 'npm:@angular',
'tslib': 'npm:tslib@2.1.0/tslib.js',
'rxjs': 'npm:rxjs@6.4.0',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18',
'devextreme-angular': 'npm:devextreme-angular@20.2.5',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js'
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts'
},
'devextreme': {
defaultExtension: 'js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
packageConfigPaths: [
"npm:@angular/*/package.json",
"npm:@angular/common/*/package.json",
"npm:rxjs/package.json",
"npm:rxjs/operators/package.json",
"npm:devextreme-angular/*/package.json",
"npm:devextreme-angular/ui/*/package.json",
"npm:devextreme-angular/package.json",
"npm:devexpress-diagram/package.json",
"npm:devexpress-gantt/package.json",
]
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.10.2/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import('app').catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<div id="chart-demo">
<DxChart
id="chart"
:data-source="weatherData"
>
<DxCommonSeriesSettings argument-field="date"/>
<DxSeries
axis="precipitation"
color="#03a9f4"
type="bar"
value-field="precipitation"
name="Precipitation"
/>
<DxSeries
axis="temperature"
color="#ffc0bb"
type="rangearea"
range-value1-field="minTemp"
range-value2-field="maxTemp"
name="Temperature range"
>
<DxAggregation
:enabled="useAggregation"
:calculate="calculateRangeArea"
method="custom"
/>
</DxSeries>
<DxSeries
axis="temperature"
color="#e91e63"
value-field="temp"
name="Average temperature"
>
<DxPoint :size="7"/>
<DxAggregation
:enabled="useAggregation"
:method="currentFunction"
/>
</DxSeries>
<DxArgumentAxis
:aggregation-interval="currentInterval"
:value-margins-enabled="false"
argument-type="datetime"
/>
<DxValueAxis name="temperature">
<DxTitle text="Temperature, °C">
<DxFont color="#e91e63"/>
</DxTitle>
<DxLabel>
<DxFont color="#e91e63"/>
</DxLabel>
</DxValueAxis>
<DxValueAxis
name="precipitation"
position="right"
>
<DxTitle text="Precipitation, mm">
<DxFont color="#03a9f4"/>
</DxTitle>
<DxLabel>
<DxFont color="#03a9f4"/>
</DxLabel>
</DxValueAxis>
<DxLegend :visible="false"/>
<DxTooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
/>
<DxTitle text="Weather in Las Vegas, NV (2017)"/>
</DxChart>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<DxCheckBox
v-model:value="useAggregation"
text="Aggregation enabled"
/>
</div>
<div class="option">
<span>Interval:</span>
<DxSelectBox
:data-source="aggregationIntervals"
v-model:value="currentInterval"
display-expr="displayName"
value-expr="interval"
/>
</div>
<div class="option">
<span>Method:</span>
<DxSelectBox
:data-source="aggregationFunctions"
v-model:value="currentFunction"
display-expr="displayName"
value-expr="func"
/>
</div>
</div>
</div>
</template>
<script>
import DxChart, {
DxCommonSeriesSettings,
DxSeries,
DxAggregation,
DxPoint,
DxArgumentAxis,
DxValueAxis,
DxTitle,
DxFont,
DxLegend,
DxLabel,
DxTooltip,
} from 'devextreme-vue/chart';
import DxCheckBox from 'devextreme-vue/check-box';
import DxSelectBox from 'devextreme-vue/select-box';
import { weatherData, aggregationFunctions, aggregationIntervals } from './data.js';
export default {
components: {
DxCheckBox,
DxSelectBox,
DxChart,
DxCommonSeriesSettings,
DxSeries,
DxAggregation,
DxPoint,
DxArgumentAxis,
DxValueAxis,
DxTitle,
DxFont,
DxLegend,
DxLabel,
DxTooltip,
},
data() {
return {
aggregationFunctions,
aggregationIntervals,
weatherData,
useAggregation: true,
currentFunction: aggregationFunctions[0].func,
currentInterval: aggregationIntervals[0].interval,
};
},
methods: {
calculateRangeArea(aggregationInfo) {
if (!aggregationInfo.data.length) {
return null;
}
const temp = aggregationInfo.data.map((item) => item.temp);
return {
date: new Date((aggregationInfo.intervalStart.valueOf()
+ aggregationInfo.intervalEnd.valueOf()) / 2),
maxTemp: Math.max.apply(null, temp),
minTemp: Math.min.apply(null, temp),
};
},
customizeTooltip(pointInfo) {
const { aggregationInfo } = pointInfo.point;
const start = aggregationInfo && aggregationInfo.intervalStart;
const end = aggregationInfo && aggregationInfo.intervalEnd;
const handlers = {
'Average temperature': (arg) => ({
text: `${(!aggregationInfo
? `Date: ${arg.argument.toDateString()}`
: `Interval: ${start.toDateString()} - ${end.toDateString()}`)
}<br/>Temperature: ${arg.value.toFixed(2)} °C`,
}),
'Temperature range': (arg) => ({
text: `Interval: ${start.toDateString()
} - ${end.toDateString()
}<br/>Temperature range: ${arg.rangeValue1
} - ${arg.rangeValue2} °C`,
}),
Precipitation: (arg) => ({
text: `Date: ${arg.argument.toDateString()
}<br/>Precipitation: ${arg.valueText} mm`,
}),
};
return handlers[pointInfo.seriesName](pointInfo);
},
},
};
</script>
<style>
#chart-demo {
height: 700px;
}
#chart {
height: 500px;
margin: 0 0 15px;
}
.options {
padding: 20px;
margin-top: 20px;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.option > span {
width: 50px;
display: inline-block;
margin-right: 14px;
}
.option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
export const aggregationIntervals = [
{ displayName: 'One week', interval: 'week' },
{ displayName: 'Two weeks', interval: { weeks: 2 } },
{ displayName: 'Month', interval: 'month' },
];
export const aggregationFunctions = [
{ displayName: 'Average', func: 'avg' },
{ displayName: 'Minimum', func: 'min' },
{ displayName: 'Maximum', func: 'max' },
];
export const weatherData = [{
date: '2017-01-01',
temp: 9.5,
precipitation: 0.1,
},
{
date: '2017-01-02',
temp: 8,
precipitation: 0.4,
},
{
date: '2017-01-03',
temp: 7.5,
precipitation: 0.2,
},
{
date: '2017-01-04',
temp: 8.5,
precipitation: 0.1,
},
{
date: '2017-01-05',
temp: 10,
precipitation: 0.3,
},
{
date: '2017-01-06',
temp: 3,
precipitation: 0,
},
{
date: '2017-01-07',
temp: 5,
precipitation: 0.3,
},
{
date: '2017-01-08',
temp: 9.5,
precipitation: 0,
},
{
date: '2017-01-09',
temp: 11,
precipitation: 0.5,
},
{
date: '2017-01-10',
temp: 8,
precipitation: 0,
},
{
date: '2017-01-11',
temp: 11.5,
precipitation: 0.3,
},
{
date: '2017-01-12',
temp: 9.5,
precipitation: 2.1,
},
{
date: '2017-01-13',
temp: 11.5,
precipitation: 3.5,
},
{
date: '2017-01-14',
temp: 11,
precipitation: 0.1,
},
{
date: '2017-01-15',
temp: 10.5,
precipitation: 0,
},
{
date: '2017-01-16',
temp: 6.5,
precipitation: 0,
},
{
date: '2017-01-17',
temp: 7.5,
precipitation: 0,
},
{
date: '2017-01-18',
temp: 8,
precipitation: 0.1,
},
{
date: '2017-01-19',
temp: 8.5,
precipitation: 1.3,
},
{
date: '2017-01-20',
temp: 5.5,
precipitation: 5.3,
},
{
date: '2017-01-21',
temp: 9,
precipitation: 0.1,
},
{
date: '2017-01-22',
temp: 6,
precipitation: 16.6,
},
{
date: '2017-01-23',
temp: 8.5,
precipitation: 5.5,
},
{
date: '2017-01-24',
temp: 6.5,
precipitation: 1.3,
},
{
date: '2017-01-25',
temp: 4.5,
precipitation: 0,
},
{
date: '2017-01-26',
temp: 5.5,
precipitation: 0,
},
{
date: '2017-01-27',
temp: 3,
precipitation: 0,
},
{
date: '2017-01-28',
temp: 6.5,
precipitation: 0,
},
{
date: '2017-01-29',
temp: 8,
precipitation: 0,
},
{
date: '2017-01-30',
temp: 10.5,
precipitation: 0,
},
{
date: '2017-01-31',
temp: 13,
precipitation: 0,
},
{
date: '2017-02-01',
temp: 10.5,
precipitation: 0,
},
{
date: '2017-02-02',
temp: 12,
precipitation: 0,
},
{
date: '2017-02-03',
temp: 13,
precipitation: 0.2,
},
{
date: '2017-02-04',
temp: 10,
precipitation: 0,
},
{
date: '2017-02-05',
temp: 11.5,
precipitation: 0,
},
{
date: '2017-02-06',
temp: 11.5,
precipitation: 0.1,
},
{
date: '2017-02-07',
temp: 12.5,
precipitation: 0.5,
},
{
date: '2017-02-08',
temp: 13,
precipitation: 0,
},
{
date: '2017-02-09',
temp: 15.5,
precipitation: 0,
},
{
date: '2017-02-10',
temp: 16.5,
precipitation: 0.1,
},
{
date: '2017-02-11',
temp: 14.5,
precipitation: 0.8,
},
{
date: '2017-02-12',
temp: 13.5,
precipitation: 0.1,
},
{
date: '2017-02-13',
temp: 13.5,
precipitation: 0,
},
{
date: '2017-02-14',
temp: 12,
precipitation: 0,
},
{
date: '2017-02-15',
temp: 13.5,
precipitation: 0,
},
{
date: '2017-02-16',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-02-17',
temp: 12.5,
precipitation: 4.5,
},
{
date: '2017-02-18',
temp: 10,
precipitation: 14.4,
},
{
date: '2017-02-19',
temp: 13.5,
precipitation: 0.5,
},
{
date: '2017-02-20',
temp: 14,
precipitation: 0.6,
},
{
date: '2017-02-21',
temp: 15,
precipitation: 0,
},
{
date: '2017-02-22',
temp: 11,
precipitation: 0,
},
{
date: '2017-02-23',
temp: 7.5,
precipitation: 0,
},
{
date: '2017-02-24',
temp: 6,
precipitation: 0,
},
{
date: '2017-02-25',
temp: 7,
precipitation: 0,
},
{
date: '2017-02-26',
temp: 8,
precipitation: 0,
},
{
date: '2017-02-27',
temp: 8.5,
precipitation: 0.1,
},
{
date: '2017-02-28',
temp: 10,
precipitation: 0,
},
{
date: '2017-03-01',
temp: 9,
precipitation: 0,
},
{
date: '2017-03-02',
temp: 11,
precipitation: 0,
},
{
date: '2017-03-03',
temp: 15,
precipitation: 0,
},
{
date: '2017-03-04',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-03-05',
temp: 12.5,
precipitation: 0,
},
{
date: '2017-03-06',
temp: 7.5,
precipitation: 0,
},
{
date: '2017-03-07',
temp: 11,
precipitation: 0,
},
{
date: '2017-03-08',
temp: 16,
precipitation: 0,
},
{
date: '2017-03-09',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-03-10',
temp: 20,
precipitation: 0,
},
{
date: '2017-03-11',
temp: 20.5,
precipitation: 0,
},
{
date: '2017-03-12',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-03-13',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-03-14',
temp: 23.5,
precipitation: 0,
},
{
date: '2017-03-15',
temp: 23,
precipitation: 0,
},
{
date: '2017-03-16',
temp: 23,
precipitation: 0,
},
{
date: '2017-03-17',
temp: 22.5,
precipitation: 0,
},
{
date: '2017-03-18',
temp: 23.5,
precipitation: 0,
},
{
date: '2017-03-19',
temp: 24,
precipitation: 0,
},
{
date: '2017-03-20',
temp: 23.5,
precipitation: 0,
},
{
date: '2017-03-21',
temp: 22,
precipitation: 0,
},
{
date: '2017-03-22',
temp: 18.5,
precipitation: 4,
},
{
date: '2017-03-23',
temp: 15,
precipitation: 2.4,
},
{
date: '2017-03-24',
temp: 20.5,
precipitation: 0,
},
{
date: '2017-03-25',
temp: 19,
precipitation: 0,
},
{
date: '2017-03-26',
temp: 18.5,
precipitation: 0,
},
{
date: '2017-03-27',
temp: 18,
precipitation: 0,
},
{
date: '2017-03-28',
temp: 17,
precipitation: 0,
},
{
date: '2017-03-29',
temp: 21,
precipitation: 0,
},
{
date: '2017-03-30',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-03-31',
temp: 16.5,
precipitation: 0.2,
},
{
date: '2017-04-01',
temp: 19,
precipitation: 0,
},
{
date: '2017-04-02',
temp: 20,
precipitation: 0,
},
{
date: '2017-04-03',
temp: 18,
precipitation: 0,
},
{
date: '2017-04-04',
temp: 16.5,
precipitation: 0,
},
{
date: '2017-04-05',
temp: 17,
precipitation: 0,
},
{
date: '2017-04-06',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-04-07',
temp: 22,
precipitation: 0,
},
{
date: '2017-04-08',
temp: 19,
precipitation: 0.2,
},
{
date: '2017-04-09',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-04-10',
temp: 17,
precipitation: 0,
},
{
date: '2017-04-11',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-04-12',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-04-13',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-04-14',
temp: 19,
precipitation: 0,
},
{
date: '2017-04-15',
temp: 21,
precipitation: 0,
},
{
date: '2017-04-16',
temp: 22.5,
precipitation: 0,
},
{
date: '2017-04-17',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-04-18',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-04-19',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-04-20',
temp: 22,
precipitation: 0,
},
{
date: '2017-04-21',
temp: 20,
precipitation: 0,
},
{
date: '2017-04-22',
temp: 23,
precipitation: 0,
},
{
date: '2017-04-23',
temp: 26,
precipitation: 0,
},
{
date: '2017-04-24',
temp: 25,
precipitation: 0,
},
{
date: '2017-04-25',
temp: 22,
precipitation: 0,
},
{
date: '2017-04-26',
temp: 23.5,
precipitation: 0,
},
{
date: '2017-04-27',
temp: 23,
precipitation: 0,
},
{
date: '2017-04-28',
temp: 19,
precipitation: 0,
},
{
date: '2017-04-29',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-04-30',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-05-01',
temp: 26,
precipitation: 0,
},
{
date: '2017-05-02',
temp: 26,
precipitation: 0,
},
{
date: '2017-05-03',
temp: 25.5,
precipitation: 0,
},
{
date: '2017-05-04',
temp: 28,
precipitation: 0,
},
{
date: '2017-05-05',
temp: 28.5,
precipitation: 0,
},
{
date: '2017-05-06',
temp: 27,
precipitation: 0.4,
},
{
date: '2017-05-07',
temp: 17,
precipitation: 0.1,
},
{
date: '2017-05-08',
temp: 17,
precipitation: 0,
},
{
date: '2017-05-09',
temp: 20,
precipitation: 1.7,
},
{
date: '2017-05-10',
temp: 19.5,
precipitation: 0.3,
},
{
date: '2017-05-11',
temp: 23,
precipitation: 0,
},
{
date: '2017-05-12',
temp: 26,
precipitation: 0,
},
{
date: '2017-05-13',
temp: 22.5,
precipitation: 0,
},
{
date: '2017-05-14',
temp: 23,
precipitation: 0,
},
{
date: '2017-05-15',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-05-16',
temp: 20,
precipitation: 0,
},
{
date: '2017-05-17',
temp: 18.5,
precipitation: 0,
},
{
date: '2017-05-18',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-05-19',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-05-20',
temp: 24,
precipitation: 0,
},
{
date: '2017-05-21',
temp: 27.5,
precipitation: 0,
},
{
date: '2017-05-22',
temp: 29,
precipitation: 0,
},
{
date: '2017-05-23',
temp: 30.5,
precipitation: 0,
},
{
date: '2017-05-24',
temp: 31,
precipitation: 0,
},
{
date: '2017-05-25',
temp: 29.5,
precipitation: 0,
},
{
date: '2017-05-26',
temp: 27,
precipitation: 0,
},
{
date: '2017-05-27',
temp: 26,
precipitation: 0,
},
{
date: '2017-05-28',
temp: 29,
precipitation: 0,
},
{
date: '2017-05-29',
temp: 30.5,
precipitation: 0,
},
{
date: '2017-05-30',
temp: 31.5,
precipitation: 0,
},
{
date: '2017-05-31',
temp: 29.5,
precipitation: 0,
},
{
date: '2017-06-01',
temp: 28,
precipitation: 0,
},
{
date: '2017-06-02',
temp: 30,
precipitation: 0,
},
{
date: '2017-06-03',
temp: 32.5,
precipitation: 0,
},
{
date: '2017-06-04',
temp: 32,
precipitation: 0,
},
{
date: '2017-06-05',
temp: 31.5,
precipitation: 0,
},
{
date: '2017-06-06',
temp: 33,
precipitation: 0,
},
{
date: '2017-06-07',
temp: 32.5,
precipitation: 0,
},
{
date: '2017-06-08',
temp: 31.5,
precipitation: 0,
},
{
date: '2017-06-09',
temp: 31.5,
precipitation: 0,
},
{
date: '2017-06-10',
temp: 29,
precipitation: 0,
},
{
date: '2017-06-11',
temp: 26,
precipitation: 0,
},
{
date: '2017-06-12',
temp: 21,
precipitation: 0,
},
{
date: '2017-06-13',
temp: 25,
precipitation: 0,
},
{
date: '2017-06-14',
temp: 30.5,
precipitation: 0,
},
{
date: '2017-06-15',
temp: 32,
precipitation: 0,
},
{
date: '2017-06-16',
temp: 34.5,
precipitation: 0,
},
{
date: '2017-06-17',
temp: 36,
precipitation: 0,
},
{
date: '2017-06-18',
temp: 36,
precipitation: 0,
},
{
date: '2017-06-19',
temp: 37.5,
precipitation: 0,
},
{
date: '2017-06-20',
temp: 39,
precipitation: 0,
},
{
date: '2017-06-21',
temp: 38,
precipitation: 0,
},
{
date: '2017-06-22',
temp: 37.5,
precipitation: 0,
},
{
date: '2017-06-23',
temp: 37,
precipitation: 0,
},
{
date: '2017-06-24',
temp: 37.5,
precipitation: 0,
},
{
date: '2017-06-25',
temp: 37,
precipitation: 0,
},
{
date: '2017-06-26',
temp: 36.5,
precipitation: 0,
},
{
date: '2017-06-27',
temp: 34,
precipitation: 0,
},
{
date: '2017-06-28',
temp: 34,
precipitation: 0,
},
{
date: '2017-06-29',
temp: 37.5,
precipitation: 0,
},
{
date: '2017-06-30',
temp: 35,
precipitation: 0,
},
{
date: '2017-07-01',
temp: 37.5,
precipitation: 0,
},
{
date: '2017-07-02',
temp: 35.5,
precipitation: 0,
},
{
date: '2017-07-03',
temp: 36.5,
precipitation: 0,
},
{
date: '2017-07-04',
temp: 37,
precipitation: 0,
},
{
date: '2017-07-05',
temp: 39,
precipitation: 0,
},
{
date: '2017-07-06',
temp: 39.5,
precipitation: 0,
},
{
date: '2017-07-07',
temp: 40,
precipitation: 0,
},
{
date: '2017-07-08',
temp: 39,
precipitation: 0,
},
{
date: '2017-07-09',
temp: 36.5,
precipitation: 0,
},
{
date: '2017-07-10',
temp: 37,
precipitation: 0,
},
{
date: '2017-07-11',
temp: 36.5,
precipitation: 0.1,
},
{
date: '2017-07-12',
temp: 36.5,
precipitation: 0,
},
{
date: '2017-07-13',
temp: 38,
precipitation: 0,
},
{
date: '2017-07-14',
temp: 39.5,
precipitation: 0,
},
{
date: '2017-07-15',
temp: 40,
precipitation: 0,
},
{
date: '2017-07-16',
temp: 38.5,
precipitation: 0,
},
{
date: '2017-07-17',
temp: 37,
precipitation: 0,
},
{
date: '2017-07-18',
temp: 37,
precipitation: 0,
},
{
date: '2017-07-19',
temp: 34,
precipitation: 0.4,
},
{
date: '2017-07-20',
temp: 34.5,
precipitation: 0,
},
{
date: '2017-07-21',
temp: 36.5,
precipitation: 0,
},
{
date: '2017-07-22',
temp: 36.5,
precipitation: 0,
},
{
date: '2017-07-23',
temp: 38,
precipitation: 0,
},
{
date: '2017-07-24',
temp: 34,
precipitation: 0.1,
},
{
date: '2017-07-25',
temp: 34,
precipitation: 0,
},
{
date: '2017-07-26',
temp: 33.5,
precipitation: 0.2,
},
{
date: '2017-07-27',
temp: 36,
precipitation: 0,
},
{
date: '2017-07-28',
temp: 38,
precipitation: 0,
},
{
date: '2017-07-29',
temp: 36.5,
precipitation: 0,
},
{
date: '2017-07-30',
temp: 37.5,
precipitation: 0.1,
},
{
date: '2017-07-31',
temp: 37,
precipitation: 0,
},
{
date: '2017-08-01',
temp: 37,
precipitation: 0,
},
{
date: '2017-08-02',
temp: 35.5,
precipitation: 0.1,
},
{
date: '2017-08-03',
temp: 33.5,
precipitation: 0.9,
},
{
date: '2017-08-04',
temp: 32,
precipitation: 0.1,
},
{
date: '2017-08-05',
temp: 33.5,
precipitation: 0.1,
},
{
date: '2017-08-06',
temp: 34,
precipitation: 0,
},
{
date: '2017-08-07',
temp: 33.5,
precipitation: 0,
},
{
date: '2017-08-08',
temp: 35.5,
precipitation: 0,
},
{
date: '2017-08-09',
temp: 36,
precipitation: 0,
},
{
date: '2017-08-10',
temp: 35.5,
precipitation: 0,
},
{
date: '2017-08-11',
temp: 35,
precipitation: 0,
},
{
date: '2017-08-12',
temp: 35.5,
precipitation: 0.1,
},
{
date: '2017-08-13',
temp: 34,
precipitation: 0,
},
{
date: '2017-08-14',
temp: 32.5,
precipitation: 0,
},
{
date: '2017-08-15',
temp: 30,
precipitation: 0,
},
{
date: '2017-08-16',
temp: 31,
precipitation: 0,
},
{
date: '2017-08-17',
temp: 33.5,
precipitation: 0,
},
{
date: '2017-08-18',
temp: 34.5,
precipitation: 0,
},
{
date: '2017-08-19',
temp: 34,
precipitation: 0,
},
{
date: '2017-08-20',
temp: 33,
precipitation: 0,
},
{
date: '2017-08-21',
temp: 32,
precipitation: 0,
},
{
date: '2017-08-22',
temp: 32.5,
precipitation: 0,
},
{
date: '2017-08-23',
temp: 33,
precipitation: 0,
},
{
date: '2017-08-24',
temp: 33,
precipitation: 0,
},
{
date: '2017-08-25',
temp: 33.5,
precipitation: 0,
},
{
date: '2017-08-26',
temp: 36,
precipitation: 0,
},
{
date: '2017-08-27',
temp: 37,
precipitation: 0,
},
{
date: '2017-08-28',
temp: 37,
precipitation: 0,
},
{
date: '2017-08-29',
temp: 36.5,
precipitation: 0,
},
{
date: '2017-08-30',
temp: 36,
precipitation: 0.3,
},
{
date: '2017-08-31',
temp: 33.5,
precipitation: 0.3,
},
{
date: '2017-09-01',
temp: 33.5,
precipitation: 0,
},
{
date: '2017-09-02',
temp: 34.5,
precipitation: 0,
},
{
date: '2017-09-03',
temp: 34,
precipitation: 0.1,
},
{
date: '2017-09-04',
temp: 29.5,
precipitation: 0,
},
{
date: '2017-09-05',
temp: 33,
precipitation: 0,
},
{
date: '2017-09-06',
temp: 32,
precipitation: 0,
},
{
date: '2017-09-07',
temp: 32,
precipitation: 0,
},
{
date: '2017-09-08',
temp: 28,
precipitation: 1.7,
},
{
date: '2017-09-09',
temp: 23,
precipitation: 7.6,
},
{
date: '2017-09-10',
temp: 29,
precipitation: 0,
},
{
date: '2017-09-11',
temp: 32,
precipitation: 0,
},
{
date: '2017-09-12',
temp: 31,
precipitation: 0,
},
{
date: '2017-09-13',
temp: 30.5,
precipitation: 0,
},
{
date: '2017-09-14',
temp: 26,
precipitation: 0,
},
{
date: '2017-09-15',
temp: 23.5,
precipitation: 0,
},
{
date: '2017-09-16',
temp: 24.5,
precipitation: 0,
},
{
date: '2017-09-17',
temp: 25,
precipitation: 0,
},
{
date: '2017-09-18',
temp: 26.5,
precipitation: 0,
},
{
date: '2017-09-19',
temp: 24.5,
precipitation: 0,
},
{
date: '2017-09-20',
temp: 24.5,
precipitation: 0,
},
{
date: '2017-09-21',
temp: 20,
precipitation: 0,
},
{
date: '2017-09-22',
temp: 17,
precipitation: 0,
},
{
date: '2017-09-23',
temp: 15.5,
precipitation: 0,
},
{
date: '2017-09-24',
temp: 17.5,
precipitation: 0,
},
{
date: '2017-09-25',
temp: 18,
precipitation: 0,
},
{
date: '2017-09-26',
temp: 18.5,
precipitation: 0,
},
{
date: '2017-09-27',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-09-28',
temp: 22,
precipitation: 0,
},
{
date: '2017-09-29',
temp: 24,
precipitation: 0,
},
{
date: '2017-09-30',
temp: 25,
precipitation: 0,
},
{
date: '2017-10-01',
temp: 23,
precipitation: 0,
},
{
date: '2017-10-02',
temp: 18,
precipitation: 0,
},
{
date: '2017-10-03',
temp: 18.5,
precipitation: 0,
},
{
date: '2017-10-04',
temp: 18.5,
precipitation: 0,
},
{
date: '2017-10-05',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-10-06',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-10-07',
temp: 23,
precipitation: 0,
},
{
date: '2017-10-08',
temp: 24,
precipitation: 0,
},
{
date: '2017-10-09',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-10-10',
temp: 18,
precipitation: 0,
},
{
date: '2017-10-11',
temp: 20,
precipitation: 0,
},
{
date: '2017-10-12',
temp: 20,
precipitation: 0,
},
{
date: '2017-10-13',
temp: 21,
precipitation: 0,
},
{
date: '2017-10-14',
temp: 17,
precipitation: 0,
},
{
date: '2017-10-15',
temp: 18,
precipitation: 0,
},
{
date: '2017-10-16',
temp: 20.5,
precipitation: 0,
},
{
date: '2017-10-17',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-10-18',
temp: 21.5,
precipitation: 0,
},
{
date: '2017-10-19',
temp: 22.5,
precipitation: 0,
},
{
date: '2017-10-20',
temp: 18,
precipitation: 0,
},
{
date: '2017-10-21',
temp: 15,
precipitation: 0,
},
{
date: '2017-10-22',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-10-23',
temp: 22,
precipitation: 0,
},
{
date: '2017-10-24',
temp: 20.5,
precipitation: 0,
},
{
date: '2017-10-25',
temp: 21,
precipitation: 0,
},
{
date: '2017-10-26',
temp: 22,
precipitation: 0,
},
{
date: '2017-10-27',
temp: 20,
precipitation: 0,
},
{
date: '2017-10-28',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-10-29',
temp: 21,
precipitation: 0,
},
{
date: '2017-10-30',
temp: 19.5,
precipitation: 0,
},
{
date: '2017-10-31',
temp: 17.5,
precipitation: 0,
},
{
date: '2017-11-01',
temp: 18,
precipitation: 0,
},
{
date: '2017-11-02',
temp: 15,
precipitation: 0,
},
{
date: '2017-11-03',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-11-04',
temp: 16.5,
precipitation: 0,
},
{
date: '2017-11-05',
temp: 12.5,
precipitation: 0,
},
{
date: '2017-11-06',
temp: 12,
precipitation: 0,
},
{
date: '2017-11-07',
temp: 14,
precipitation: 0,
},
{
date: '2017-11-08',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-11-09',
temp: 16.5,
precipitation: 0,
},
{
date: '2017-11-10',
temp: 16,
precipitation: 0,
},
{
date: '2017-11-11',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-11-12',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-11-13',
temp: 16.5,
precipitation: 0,
},
{
date: '2017-11-14',
temp: 14.5,
precipitation: 0,
},
{
date: '2017-11-15',
temp: 16.5,
precipitation: 0,
},
{
date: '2017-11-16',
temp: 15,
precipitation: 0,
},
{
date: '2017-11-17',
temp: 17,
precipitation: 0,
},
{
date: '2017-11-18',
temp: 8.5,
precipitation: 0,
},
{
date: '2017-11-19',
temp: 11,
precipitation: 0,
},
{
date: '2017-11-20',
temp: 12,
precipitation: 0,
},
{
date: '2017-11-21',
temp: 15.5,
precipitation: 0,
},
{
date: '2017-11-22',
temp: 18.5,
precipitation: 0,
},
{
date: '2017-11-23',
temp: 18.5,
precipitation: 0,
},
{
date: '2017-11-24',
temp: 18,
precipitation: 0,
},
{
date: '2017-11-25',
temp: 18.5,
precipitation: 0,
},
{
date: '2017-11-26',
temp: 17.5,
precipitation: 0,
},
{
date: '2017-11-27',
temp: 13,
precipitation: 0,
},
{
date: '2017-11-28',
temp: 10,
precipitation: 0,
},
{
date: '2017-11-29',
temp: 12.5,
precipitation: 0,
},
{
date: '2017-11-30',
temp: 11.5,
precipitation: 0,
},
{
date: '2017-12-01',
temp: 14,
precipitation: 0,
},
{
date: '2017-12-02',
temp: 13.5,
precipitation: 0,
},
{
date: '2017-12-03',
temp: 13.5,
precipitation: 0,
},
{
date: '2017-12-04',
temp: 4.5,
precipitation: 0,
},
{
date: '2017-12-05',
temp: 5,
precipitation: 0,
},
{
date: '2017-12-06',
temp: 7,
precipitation: 0,
},
{
date: '2017-12-07',
temp: 6.5,
precipitation: 0,
},
{
date: '2017-12-08',
temp: 10,
precipitation: 0,
},
{
date: '2017-12-09',
temp: 10,
precipitation: 0,
},
{
date: '2017-12-10',
temp: 10,
precipitation: 0,
},
{
date: '2017-12-11',
temp: 10.5,
precipitation: 0,
},
{
date: '2017-12-12',
temp: 12,
precipitation: 0,
},
{
date: '2017-12-13',
temp: 12.5,
precipitation: 0,
},
{
date: '2017-12-14',
temp: 9,
precipitation: 0,
},
{
date: '2017-12-15',
temp: 10,
precipitation: 0,
},
{
date: '2017-12-16',
temp: 8,
precipitation: 0,
},
{
date: '2017-12-17',
temp: 6,
precipitation: 0,
},
{
date: '2017-12-18',
temp: 7.5,
precipitation: 0,
},
{
date: '2017-12-19',
temp: 9.5,
precipitation: 0,
},
{
date: '2017-12-20',
temp: 8.5,
precipitation: 0,
},
{
date: '2017-12-21',
temp: 3,
precipitation: 0,
},
{
date: '2017-12-22',
temp: 4,
precipitation: 0,
},
{
date: '2017-12-23',
temp: 6,
precipitation: 0,
},
{
date: '2017-12-24',
temp: 8,
precipitation: 0,
},
{
date: '2017-12-25',
temp: 10,
precipitation: 0,
},
{
date: '2017-12-26',
temp: 11,
precipitation: 0,
},
{
date: '2017-12-27',
temp: 12,
precipitation: 0,
},
{
date: '2017-12-28',
temp: 12,
precipitation: 0,
},
{
date: '2017-12-29',
temp: 13.5,
precipitation: 0,
},
{
date: '2017-12-30',
temp: 12,
precipitation: 0,
},
{
date: '2017-12-31',
temp: 11,
precipitation: 0,
}];
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.2.47/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.5/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.2.5',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.42/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);